<cfcomponent 
	extends="writer"
	displayname="Form HANDLER" 
	hint="gestisce la form"
>

<!--- GESTIONE CONTROLLI ---------------------------------------------------->
<cffunction name="lineCK" access="private" returntype="void" 
	hint="utility per runCK: sceglie controlli su linea standard">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfscript>
		tmpControlli=XMLSearch(MyXML, "tipoControllo");
		for (j=1; j LTE ArrayLen(tmpControlli); j++){
			// scorre tutti i controlli da fare per una singola linea
			switch ( tmpControlli[j].XmlText ) {
				case "": break; // nessun controllo
				case "notNull": 
					THIS.eObj.notNull( tmpXML.key.XmlText, FORM[ tmpXML.key.XmlText ]); 
					break;
				case "notOne": 
					THIS.eObj.notOne( tmpXML.key.XmlText, FORM[ tmpXML.key.XmlText ]); 
					break;


				case "notThis": 
					THIS.eObj.notThis( tmpXML.key.XmlText, FORM[ tmpXML.key.XmlText ], tmpControlli[j].XmlAttributes.number); 
					break;
				case "notChooseVoice": 
					THIS.eObj.notChooseVoice( tmpXML.key.XmlText, FORM[ tmpXML.key.XmlText ], tmpControlli[j].XmlAttributes.value); 
					break;
				case "isCF": 
					THIS.eObj.isCF( tmpXML.key.XmlText, FORM[ tmpXML.key.XmlText ], stringToBoolean(tmpXML.mandatory.XmlText) ); 
					break;
				case "isIVA": 
					THIS.eObj.isIVA( tmpXML.key.XmlText, FORM[ tmpXML.key.XmlText ], stringToBoolean(tmpXML.mandatory.XmlText) ); 
					break;
				case "isIVAorCF": 
					THIS.eObj.isIVAorCF( tmpXML.key.XmlText, FORM[ tmpXML.key.XmlText ], stringToBoolean(tmpXML.mandatory.XmlText) ); 
					break;
				case "isCAP": 
					THIS.eObj.isCAP( tmpXML.key.XmlText, FORM[ tmpXML.key.XmlText ], stringToBoolean(tmpXML.mandatory.XmlText) ); 
					break;


				case "isMail": 
					THIS.eObj.isMail( tmpXML.key.XmlText, FORM[ tmpXML.key.XmlText ], stringToBoolean(tmpXML.mandatory.XmlText) ); 
					break;
				case "isTelefono": 
					THIS.eObj.isTelefono( tmpXML.key.XmlText, FORM[ tmpXML.key.XmlText ], stringToBoolean(tmpXML.mandatory.XmlText) ); 
					break;
				case "isNumber": 
					THIS.eObj.isNumber( tmpXML.key.XmlText, FORM[ tmpXML.key.XmlText ], stringToBoolean(tmpXML.mandatory.XmlText) ); 
					break;
				case "isData": 
					THIS.eObj.isDataMix( tmpXML.key.XmlText, FORM[ tmpXML.key.XmlText ], stringToBoolean(tmpXML.mandatory.XmlText) ); 
					break;
				default : writeOutput("ERRORE: tipo controllo [" & tmpControlli[j].XmlText & "] della key [" & tmpXML.key.XmlText & "] non presente"); break;
			} // END Switch
		} // END for
	</cfscript>
	
</cffunction>


<cffunction name="ckboxCK" access="private" returntype="void"
	hint="utility per runCK: sceglie controlli su gruppo di checkbox">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfscript>
		tmpElem = XMLSearch(MyXML, "element");
		// scorre le key del gruppo di ckbox
		for (j=1; j LTE ArrayLen(tmpElem); j++) {
			tmpControlli=XMLSearch(tmpElem[j], "tipoControllo");
			// scrorre i controlli di una singola key
			for (k=1; k LTE ArrayLen(tmpControlli); k++) {
				switch ( tmpControlli[k].XmlText ) {
					case "": break; // nessun controllo
					case "isON": 
						if ( IsDefined("FORM." & tmpElem[j].key.XmlText) )
							THIS.eObj.isON( tmpElem[j].key.XmlText, FORM[ tmpElem[j].key.XmlText ], stringToBoolean(tmpElem[j].mandatory.XmlText) ); 
						else
							THIS.eObj.isON( tmpElem[j].key.XmlText, "off", stringToBoolean(tmpElem[j].mandatory.XmlText) ); 
						break;
					default : 
						writeOutput("ERRORE: tipo controllo [" 
							& tmpControlli[j].XmlText & "] della key [" 
							& tmpXML.key.XmlText & "] non disponibile in CHECKBOX"); 
						break;
				} // END Switch
			}
		}
	</cfscript>

</cffunction>


<cffunction name="runCK" access="private" returntype="void">

	<cfscript>
		// estrae righe dal file xml
		tmpLinea=XMLSearch(THIS.fdXML, "mixForm/linee/linea");
		// cicla fra le righe
		for (i=1; i LTE ArrayLen(tmpLinea); i++) {
			tmpXML=tmpLinea[i];
			// controlla che le rige siano eseguibili 
			if ( isLineRunable( tmpXML ) ) {
				// sceglia quale tipo di controlli fare
				// NB: indispensabile perche' ad esempio ckbox ha piu' key nella stessa linea
				switch( tmpXML.tipoInput.XmlText ) {
					case "checkbox": 
						ckboxCK( tmpXML ); 
						break;
					case "title": 
						// do nothing
						break;
					case "text": 
						// do nothing
						break;
					default: 
						lineCK( tmpXML );
						break;
				}//END Switch
			}
		}
	</cfscript>

</cffunction>


<!--- GESTIONE CREAZIONE LINEE ---------------------------------------------->
<cffunction name="createLines" access="private" returntype="void">
	<cfdump var="#THIS.fdXML#">
	<cfscript>
		// estrae righe dal file xml
		tmp=XMLSearch(THIS.fdXML, "mixForm/linee/linea");
		dumper(tmp);
		// cicla fra le righe
		for (i=1; i LTE ArrayLen(tmp); i++) {
			writeOutput("riga[" & i & "] * ");
/*			
			// controlla se eseguire la riga
			if ( isLineRunable(tmp[i]) ) {
				//sceglie quale riga stampare
				switch ( tmp[i].tipoInput.XmlText ) {
					case "title": 
						createTitle(tmp[i]);	
						break;
					case "hidden": 
						createHidden(tmp[i]);	
						break;
					case "text": 
						createText(tmp[i]);	
						break;
					case "notice": 
						createNotice(tmp[i]);	
						break;
					case "input": 
						createInput(tmp[i]);	
						break;
					case "password":
						createPassword(tmp[i]);
						break;
					case "textArea": 
						createTextArea(tmp[i]);	
						break;
					case "dateInput": 
						createDateInput(tmp[i]);	
						break;
					case "selectFromSmartTable": 
						createSelectFromSmartTable(tmp[i]);	
						break;
					case "selectFromSimpleBlobTable": 
						createSelectFromSimpleBlobTable(tmp[i]);	
						break;
					case "radioFromSmartTable": 
						createRadioFromSmartTable(tmp[i]);	
						break;
					case "radio": 
						createRadio(tmp[i]);	
						break;
					case "checkbox": 
						createCKBox(tmp[i]);	
						break;
					case "fileChooser": 
						createFileChooser(tmp[i]);	
						break;
					case "selectFromDirectory": 
						createSelectFromDirectory(tmp[i]);	
						break;
					default: 
						createInput(tmp[i]);	
						break;
				} //END Switch
			}
*/
		}
	</cfscript>

</cffunction>

<!--- CREAZIONE FORM -------------------------------------------------------->
<cffunction name="createForm" access="public" returntype="void">
ENTRO
	<cfoutput>
		<div id="formWrapper">
		<cfform action="#THIS.fdXML.mixForm.parametri.azione.XmlText#"  method="#THIS.fdXML.mixForm.parametri.metodo.XmlText#" enctype="multipart/form-data">
		
			<!-- titolo -->
			<cfscript>
				tmpTitolo="";
				tmpArray=XMLSearch( THIS.fdXML, "mixForm/parametri/titolo" );
				for (k=1; k LTE ArrayLen(tmpArray); k++) {
					if ( tmpArray[k].XmlAttributes.lang EQ THIS.language ) tmpTitolo=tmpArray[k].XmlText;
				}
			</cfscript>
			<cfif tmpTitolo NEQ ""><H1>#tmpTitolo#</H1></cfif>
			
			<!-- errore -->
			<cfif NOT THIS.eObj.errorFree() ><div id="mainError">#THIS.eObj.getGeneralError()#</div></cfif>

			<!-- linee -->
			<cfscript>createLines();</cfscript>			

			<label><input type="submit" name="Invia" id="Invia" value="Invia" /></label>
			<input class="hidden" type="hidden" id="Run" name="Run" value="#FORM.Run#" />
		</cfform>
		</div>
	</cfoutput>
ESCO
</cffunction>

</cfcomponent>