<cfcomponent 
	extends="loader"
	displayname="Form WRITER" 
	hint="gestione HTML, stampa singole righe"
>

<!--- UTILITY: da stringa a boolean ----------------------------------------->
<cffunction name="stringToBoolean" access="public" returntype="boolean">
	<cfargument name="MyVal" type="string" required="yes">
	
	<cfscript>
		MyRet=false;
		if ( (MyVal IS "yes") OR (MyVal IS "true") ) MyRet = true;
		return(MyRet);
	</cfscript>
	
</cffunction>

<!--- HTML: scrive il DOT in testa alla righe -------------------------------->
<cffunction name="createDot" access="private" returntype="string">
	<cfargument name="MyDot" type="string" required="yes">

	<cfscript>
		MyRet="";
		switch ( THIS.fdXML.mixForm.parametri.stileDot.XmlText ) { 
			case "char": {
				switch ( MyDot ) {
					case "error": MyRet="<span class=""dot"">!</span>"; break;
					case "mandatory": MyRet="<span class=""dot"">*</span>"; break;
					default: break;
				} //end stile "char"
				break;
			}
			case "empty": {
				switch ( MyDot ) {
					case "error": MyRet="<span class=""dot""> </span>"; break;
					case "mandatory": MyRet="<span class=""dot""> </span>"; break;
					default: break;
				} //end stile "empty"
				break;
			}
			default: {
				switch ( MyDot ) {
					case "error": MyRet="<span class=""dot""> </span>"; break;
					case "mandatory": MyRet="<span class=""dot""> </span>"; break;
					default: break;
				} //end stile "default"
				break;
			}
		}//FINE switch esterno
		return(MyRet);
	</cfscript>

</cffunction>


<!--- HTML: scrive la LABEL scegliendo la lingua ----------------------------->
<cffunction name="createLabel" access="private" returntype="string">
	<cfargument name="MyXML" type="xml" required="yes">
	
	<cfscript>
		MyLabel="XML ERROR: LABEL in language [" & THIS.language & "] not found!";
		tmpArray=XMLSearch( MyXML, "label" );
		for (j=1; j LTE ArrayLen(tmpArray); j++) {
			if ( tmpArray[j].XmlAttributes.lang EQ THIS.language ) MyLabel=tmpArray[j].XmlText;
		}
		return( MyLabel );
	</cfscript>
	
</cffunction>


<!--- HTML: crea una linea TITOLO -------------------------------------------->
<cffunction name="createTitle" access="public" returntype="void">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfoutput><h3>#createLabel(MyXML)#</h3></cfoutput>

</cffunction>

<!--- HTML: crea una linea NOTICE -------------------------------------------->
<cffunction name="createNotice" access="public" returntype="void">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfoutput><h4>#createLabel(MyXML)#</h4></cfoutput>

</cffunction>

<!--- HTML: crea una linea TESTO --------------------------------------------->
<cffunction name="createText" access="public" returntype="void">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfoutput><div class="text">#createLabel(MyXML)#</div></cfoutput>

</cffunction>



<!--- NEW: ------------------------------------------------------------------->
<!--- HTML: crea una linea INPUT per file ------------------------------------>
<cffunction name="createFileChooser" access="public" returntype="void">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfscript>
		tKey=MyXML.key.XmlText;
		tMandatory=stringToBoolean(MyXML.mandatory.XmlText);
	</cfscript>
	<cfoutput>
		<cfif THIS.eObj.isError(tKey) >
			<label id="myForm_#tKey#" class="error">#createDot("error")# #createLabel(MyXML)# <span class="message">#THIS.eObj.getError(tKey)#</span>
				<input type="file" name="#tKey#" id="#tKey#" value="#FORM[ tKey ]#">
			</label>
		<cfelse>
			<cfif tMandatory >
				<label id="myForm_#tKey#">#createDot("mandatory")# #createLabel(MyXML)#
					<input type="file" name="#tKey#" id="#tKey#" value="#FORM[ tKey ]#">
				</label>
			<cfelse>
				<label id="myForm_#tKey#">#createLabel(MyXML)#
					<input type="file" name="#tKey#" id="#tKey#" value="#FORM[ tKey ]#">
				</label>
			</cfif>
		</cfif> 
	</cfoutput>

</cffunction>


<!--- NEW: ------------------------------------------------------------------->
<!--- HTML: crea una linea SELECT da una directory --------------------------->
<cffunction name="directoryToSelect" access="private" returntype="void" >
	<cfargument name="MyKey" type="string" required="yes">
	<cfargument name="MyDirectory" type="query" required="yes">
	
	<cfoutput><select name="#MyKey#"></cfoutput>
		<cfoutput query="MyDirectory">
			<cfset mySelected="">
			<cfif FORM[ ARGUMENTS.MyKey ] EQ name><cfset mySelected="selected=""selected"""></cfif>
			<option value="#name#" #mySelected#>#name#</option>
		</cfoutput>
	</select>

</cffunction>


<cffunction name="createSelectFromDirectory" access="public" returntype="void">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfscript>
		tKey=MyXML.key.XmlText;
		tMandatory=stringToBoolean( MyXML.mandatory.XmlText );
		// crea la tabella da cui ricavare la form
		myDir=MyXML.path.XmlText;
		// NB: si aspetta di trovare la locazione assoluta di Application in SESSION.ApplicationDir
		if (isDefined( "SESSION.ApplicationDir" )) myDir=SESSION.ApplicationDir & myDir;
	</cfscript>

	<cfdirectory directory="#myDir#" action="list" recurse="no" sort="name" listInfo="name" name="myQr" type="file">
	<cfoutput>
		<cfif THIS.eObj.isError(tKey) >
			<label class="error">#createDot("error")# #createLabel(MyXML)# <span class="message">#THIS.eObj.getError(tKey)#</span>
				#directoryToSelect( MyXML.key.XmlText, myQr )#
			</label>
		<cfelse>
			<cfif tMandatory >
				<label>#createDot("mandatory")# #createLabel(MyXML)#
				#directoryToSelect( MyXML.key.XmlText, myQr )#
				</label>
			<cfelse>
				<label>#createLabel(MyXML)#
				#directoryToSelect( MyXML.key.XmlText, myQr )#
				</label>
			</cfif>
		</cfif> 
	</cfoutput>

</cffunction>




<!--- HTML: crea una linea INPUT STANDARD ------------------------------------>
<cffunction name="createInput" access="public" returntype="void">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfscript>
		tKey=MyXML.key.XmlText;
		tMandatory=stringToBoolean(MyXML.mandatory.XmlText);
	</cfscript>
	<cfoutput>
		<cfif THIS.eObj.isError(tKey) >
			<label id="myForm_#tKey#" class="error">#createDot("error")# #createLabel(MyXML)# <span class="message">#THIS.eObj.getError(tKey)#</span>
				<input type="text" name="#tKey#" id="#tKey#" value="#FORM[ tKey ]#">
			</label>
		<cfelse>
			<cfif tMandatory >
				<label id="myForm_#tKey#">#createDot("mandatory")# #createLabel(MyXML)#
					<input type="text" name="#tKey#" id="#tKey#" value="#FORM[ tKey ]#">
				</label>
			<cfelse>
				<label id="myForm_#tKey#">#createLabel(MyXML)#
					<input type="text" name="#tKey#" id="#tKey#" value="#FORM[ tKey ]#">
				</label>
			</cfif>
		</cfif> 
	</cfoutput>

</cffunction>

<!--- HTML: crea una linea HIDDEN ------------------------------->
<cffunction name="createHidden" access="public" returntype="void">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfoutput>
		<cfset tKey=MyXML.key.XmlText>
		<input type="hidden" name="#tKey#" class="hidden" value="#FORM[ tKey ]#">
		<!--- <input type="hidden" name="#tKey#" id="#tKey#" class="hidden" value="#FORM[ tKey ]#"> --->
	</cfoutput>

</cffunction>


<!--- HTML: crea una linea PASSWORD ------------------------------------------>
<cffunction name="createPassword" access="public" returntype="void">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfscript>
		tKey=MyXML.key.XmlText;
		tMandatory=stringToBoolean(MyXML.mandatory.XmlText);
	</cfscript>
	<cfoutput>
		<cfif THIS.eObj.isError(tKey) >
			<label class="error">#createDot("error")# #createLabel(MyXML)# <span class="message">#THIS.eObj.getError(tKey)#</span>
				<input type="password" name="#tKey#" id="#tKey#" value="#FORM[ tKey ]#">
			</label>
		<cfelse>
			<cfif tMandatory >
				<label>#createDot("mandatory")# #createLabel(MyXML)#
					<input type="password" name="#tKey#" id="#tKey#" value="#FORM[ tKey ]#">
				</label>
			<cfelse>
				<label>#createLabel(MyXML)#
					<input type="password" name="#tKey#" id="#tKey#" value="#FORM[ tKey ]#">
				</label>
			</cfif>
		</cfif> 
	</cfoutput>

</cffunction>


<!--- HTML: crea una linea DATA ---------------------------------------------->
<cffunction name="createDateInput" access="public" returntype="void">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfscript>
		tKey=MyXML.key.XmlText;
		tMandatory=stringToBoolean(MyXML.mandatory.XmlText);
		// controlla se e' possiobile scrivere la data 
		if ( IsDate(FORM[ tKey ]) ) 
			MyDate=lsDateFormat(FORM[ tKey ], "dd/mm/yyyy");
		else
			MyDate=FORM[ tKey ];
		// mette hint sotto date?
		tHint=true;
		if ( IsDefined("MyXML.hint") ) tHint=stringToBoolean(MyXML.hint.XmlText);
	</cfscript>
	<cfoutput>
		<cfif THIS.eObj.isError(tKey) >
			<label id="myForm_#tKey#" class="error">#createDot("error")# #createLabel(MyXML)# <span class="message">#THIS.eObj.getError(tKey)#</span>
				<input type="text" name="#tKey#" id="#tKey#" value="#MyDate#">
			</label>
		<cfelse>
			<cfif tMandatory >
				<label id="myForm_#tKey#" >#createDot("mandatory")# #createLabel(MyXML)#
					<input type="text" name="#tKey#" id="#tKey#" value="#MyDate#">
					<cfif tHint><span class="hint">#LSDateFormat(MyDate, "dddd dd mmmm yyyy")#</span></cfif>
				</label>
			<cfelse>
				<label id="myForm_#tKey#">#createLabel(MyXML)#
					<input type="text" name="#tKey#" id="#tKey#" value="#MyDate#">
					<cfif tHint><span class="hint">#LSDateFormat(MyDate, "dddd dd mmmm yyyy")#</span></cfif>
				</label>
			</cfif>
		</cfif> 
	</cfoutput>

</cffunction>


<!--- HTML: crea una linea TEXTAREA ------------------------------------------>
<cffunction name="createTextArea" access="public" returntype="void">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfscript>
		tKey=MyXML.key.XmlText;
		tMandatory=stringToBoolean(MyXML.mandatory.XmlText);
		tH=5; 
		if ( isDefined("MyXML.H") ) tH=val(MyXML.H.XmlText);
		tW=20;
		if ( isDefined("MyXML.W") ) tW=val(MyXML.W.XmlText);
	</cfscript>
	<cfoutput>
		<cfif THIS.eObj.isError(tKey) >
			<label id="myForm_#tKey#" class="error">#createDot("error")# #createLabel(MyXML)# <span class="message">#THIS.eObj.getError(tKey)#</span>
				<textarea name="#tKey#" id="#tKey#" cols="#tW#" rows="#tH#">#FORM[ tKey ]#</textarea>
			</label>
		<cfelse>
			<cfif tMandatory >
				<label id="myForm_#tKey#">#createDot("mandatory")# #createLabel(MyXML)#
					<textarea name="#tKey#" id="#tKey#" cols="#tW#" rows="#tH#">#FORM[ tKey ]#</textarea>
				</label>
			<cfelse>
				<label id="myForm_#tKey#">#createLabel(MyXML)#
					<textarea name="#tKey#" id="#tKey#" cols="#tW#" rows="#tH#">#FORM[ tKey ]#</textarea>
				</label>
			</cfif>
		</cfif> 
	</cfoutput>

</cffunction>



<!--- HTML: crea una linea DROPDOWN (da database) ---------------------------------->
<cffunction name="createSelectLine" access="private" returntype="string" output="no">
	<cfargument name="MyKey" type="string" required="yes">
	<cfargument name="MyVal" type="string" required="yes">
	<cfargument name="MyText" type="string" required="yes">
	<cfargument name="MyFlagList" type="string" required="yes">
	
	<cfscript>
		MyRet="";
		if ( isFlagMatch( MyFlagList, THIS.flagList ) ) {
			MyRet="<option value=""" & MyVal & """ ";
			if ( FORM[ MyKey ] EQ MyVal ) MyRet=MyRet & "selected=""selected""";
			MyRet=MyRet & ">" & MyText & "</option>";
		}	
		return( MyRet );
	</cfscript>

</cffunction>

<cffunction name="smartTableToSelect" access="private" returntype="void" >
	<cfargument name="MyKey" type="string" required="yes">
	<cfargument name="MySmartTable" type="query" required="yes">
	
	<cfset lastLine="">
	<cfoutput><select name="#MyKey#"></cfoutput>
		<cfoutput query="MySmartTable">
			<cfscript>
				// cerca la prima e l'ultima riga (se ci sono)
				switch( line_type ) {
					case "hidden": break;
					case "choose": writeOutput( createSelectLine( MyKey, MyVal, text, flag_list ) ); break;
					case "other": lastLine=createSelectLine( MyKey, MyVal, text, flag_list ); break;
					case "normal": break;
					default: 
						writeOutput("ERRORE: non riconosciuto il tipo linea [" & line_type & "]");
						break;
				}//END switch
			</cfscript>
		</cfoutput>
		<cfoutput query="MySmartTable">
			<cfscript>
				// scrive le righe centrali
				switch( line_type ) {
					case "hidden": break;
					case "choose": break;
					case "other": break;
					case "normal": writeOutput( createSelectLine( MyKey, MyVal, text, flag_list ) );  break;
					default: 
						writeOutput("ERRORE: non riconosciuto il tipo linea [" & line_type & "]");
						break;
				}//END switch
			</cfscript>
		</cfoutput>
		<cfscript>
			// scrive l'ultima riga
			if ( lastLine NEQ "" ) writeOutput( lastLine ); 
		</cfscript>
	</select>

</cffunction>

<cffunction name="createSelectFromSmartTable" access="public" returntype="void">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfscript>
		tKey=MyXML.key.XmlText;
		tMandatory=stringToBoolean( MyXML.mandatory.XmlText );
		// crea la tabella da cui ricavare la form
		THIS.dbObj=createObject("component", "db");
		THIS.formTable=THIS.dbObj.buildSmartTable( MyXML, THIS.language );
	</cfscript>

	<cfoutput>
		<cfif THIS.eObj.isError(tKey) >
			<label class="error">#createDot("error")# #createLabel(MyXML)# <span class="message">#THIS.eObj.getError(tKey)#</span>
				#smartTableToSelect( MyXML.key.XmlText, THIS.formTable )#
			</label>
		<cfelse>
			<cfif tMandatory >
				<label>#createDot("mandatory")# #createLabel(MyXML)#
				#smartTableToSelect( MyXML.key.XmlText, THIS.formTable )#
				</label>
			<cfelse>
				<label>#createLabel(MyXML)#
				#smartTableToSelect( MyXML.key.XmlText, THIS.formTable )#
				</label>
			</cfif>
		</cfif> 
	</cfoutput>

</cffunction>



<!--- HTML: crea una linea DROPDOWN (da database SIMPLEBLOBTABLE) ------------------>
<cffunction name="simpleBlobTableToSelect" access="private" returntype="void" >
	<cfargument name="MyKey" type="string" required="yes">
	<cfargument name="MyBlobTable" type="query" required="yes">
	
	<cfscript>
		tmpBlob=createObject("component", "mixCFC.blob.blob");
		tmpBlob.setLanguageSeekMode("lose");
		tmpBlob.setReturnMode("normal");
		tmpBlob.setlanguage( getLanguage() );
	</cfscript>
	<cfoutput><select name="#MyKey#"></cfoutput>
	<cfoutput query="MyBlobTable">
		<cfscript>tmpBlob.load( myBlob );</cfscript>
		<cfif ( FORM[ ARGUMENTS.MyKey ] EQ myValue )>
			<option value="#myValue#" selected="selected">#tmpBlob.get()#</option>
		<cfelse>
			<option value="#myValue#">#tmpBlob.get()#</option>
		</cfif>
	</cfoutput>
	</select>

</cffunction>

<cffunction name="createSelectFromSimpleBlobTable" access="public" returntype="void">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfscript>
		tKey=MyXML.key.XmlText;
		tMandatory=stringToBoolean( MyXML.mandatory.XmlText );
		// crea la tabella da cui ricavare la form
		THIS.dbObj=createObject("component", "db");
		THIS.blobTable=THIS.dbObj.getSimpleBlobTable( MyXML );
	</cfscript>

	<cfoutput>
		<cfif THIS.eObj.isError(tKey) >
			<label id="myForm_#tKey#" class="error">#createDot("error")# #createLabel(MyXML)# <span class="message">#THIS.eObj.getError(tKey)#</span>
				#simpleBlobTableToSelect( MyXML.key.XmlText, THIS.blobTable )#
			</label>
		<cfelse>
			<cfif tMandatory >
				<label id="myForm_#tKey#">#createDot("mandatory")# #createLabel(MyXML)#
				#simpleBlobTableToSelect( MyXML.key.XmlText, THIS.blobTable )#
				</label>
			<cfelse>
				<label id="myForm_#tKey#">#createLabel(MyXML)#
				#simpleBlobTableToSelect( MyXML.key.XmlText, THIS.blobTable )#
				</label>
			</cfif>
		</cfif> 
	</cfoutput>

</cffunction>





<!--- HTML: crea una linea RADIO (da database) ------------------------->
<cffunction name="smartTableToRadio" access="private" returntype="void" >
	<cfargument name="MyKey" type="string" required="yes">
	<cfargument name="MySmartTable" type="query" required="yes">
	
	<!--- NB: controlla che *effettivamente* FORM[ MyKey ] abbia un valore compreso nel rdio, o glielo assegna d'ufficio --->
	<cfset found=false>
	<cfoutput query="MySmartTable">
		<cfif FORM[ MyKey ] EQ MyVal ><cfset found=true ></cfif>
		<cfset tmpVal=MyVal >
	</cfoutput>
	<cfif NOT found ><cfset FORM[ MyKey ]=tmpVal ></cfif>

	<cfoutput query="MySmartTable">
		<cfif FORM[ MyKey ] EQ MyVal ><cfset ck="checked=""checked"""><cfelse><cfset ck=""></cfif>
		<cfif isFlagMatch( flag_list, THIS.flagList )>
			<li><label><input type="radio" name="#MyKey#" id="#MyKey#" value="#MyVal#" class="radio" #ck#/> #text#</label></li>
		</cfif>
	</cfoutput>

</cffunction>

<cffunction name="createRadioFromSmartTable" access="public" returntype="void">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfscript>
		tKey=MyXML.key.XmlText;
		tMandatory=stringToBoolean( MyXML.mandatory.XmlText );
		// crea la tabella da cui ricavare la form
		THIS.dbObj=createObject("component", "db");
		THIS.formTable=THIS.dbObj.buildSmartTable( MyXML, THIS.language );
	</cfscript>
	<cfoutput>
		<cfif THIS.eObj.isError(tKey) >
			<ul class="error">
				<li>#createDot("error")# #createLabel(MyXML)# <span class="message">#THIS.eObj.getError(tKey)#</span></li>
				#smartTableToRadio( MyXML.key.XmlText, THIS.formTable )#
			</ul>
		<cfelse>
			<cfif tMandatory >
				<ul>
					<li>#createDot("mandatory")# #createLabel(MyXML)#</li>
					#smartTableToRadio( MyXML.key.XmlText, THIS.formTable )#
				</ul>
			<cfelse>
				<ul>
					<li>#createLabel(MyXML)#</li>
					#smartTableToRadio( MyXML.key.XmlText, THIS.formTable )#
				</ul>
			</cfif>
		</cfif> 
	</cfoutput>

</cffunction>


<!--- HTML: crea una linea bottoni RADIO ------------------------------------->
<cffunction name="createRadioLine" access="private" returntype="void" 
	hint="utility per funzione createRadio">
	<cfargument name="MyEA" type="array" required="yes">
	<cfargument name="MytKey" type="string" required="yes">
	
	<cfloop index="m" from="1" to="#ArrayLen(MyEA)#" step="1">
		<cfif FORM[ MytKey ] EQ MyEA[m].value.XmlText ><cfset ck="checked=""checked"""><cfelse><cfset ck=""></cfif>
		<cfoutput>
			<li><lebel id="myForm_#MytKey#"><input type="radio" name="#MytKey#" id="#MytKey#" value="#MyEA[m].value.XmlText#" class="radio" #ck# />	#createLabel( MyEA[m] )#</label></li>
		</cfoutput>
	</cfloop>

</cffunction>

<cffunction name="createRadio" access="public" returntype="void">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfscript>
		tKey=MyXML.key.XmlText;
		tMandatory=stringToBoolean(MyXML.mandatory.XmlText);
	</cfscript>
	<cfoutput>
		<cfif THIS.eObj.isError(tKey) >
			<ul class="error">
				<li>#createDot("error")# #createLabel(MyXML)# <span class="message">#THIS.eObj.getError(tKey)#</span></li>
				<cfscript>createRadioLine(XMLSearch( MyXML, "element" ), tKey);</cfscript>
			</ul>
		<cfelse>
			<cfif tMandatory >
				<ul>
					<li>#createDot("mandatory")# #createLabel(MyXML)#</li>
					<cfscript>createRadioLine(XMLSearch( MyXML, "element" ), tKey);</cfscript>
				</ul>
			<cfelse>
				<ul>
					<li>#createLabel(MyXML)#</li>
					<cfscript>createRadioLine(XMLSearch( MyXML, "element" ), tKey);</cfscript>
				</ul>
			</cfif>
		</cfif> 
	</cfoutput>

</cffunction>



<!--- HTML: crea una linea box CHECKBOX -------------------------------------->
<cffunction name="createCKBoxLine" access="public" returntype="void" 
	hint="funzione di utilty per createCKBox">
	<cfargument name="MyEA" type="array" required="yes">

	<cfloop index="m" from="1" to="#ArrayLen(MyEA)#" step="1">
		<cfscript>
			sString="";
			tmpKey=MyEA[m].key.XmlText;
			if ( isDefined("FORM." & tmpKey) )
				// TASSATIVO mettere nested questo if, potrebbe non esistere FORM[ tmpKey ]
				if ( FORM[ tmpKey ] EQ "on" ) 
					sString="checked=""checked""";
		</cfscript>
		<cfoutput>
			<li>
				<label id="myForm_#tmpKey#">
					<input type="checkbox" name="#tmpKey#" id="#tmpKey#" class="checkbox" #sString# />
					<cfif NOT THIS.eObj.isError(tmpKey) AND stringToBoolean( MyEA[m].mandatory.XmlText) >#createDot("mandatory")#</cfif>
					#createLabel( MyEA[m] )#
					<cfif THIS.eObj.isError(tmpKey)><span class="message">#THIS.eObj.getError(tmpKey)#</span></cfif>
				</label>
			</li>
		</cfoutput>
	</cfloop>

</cffunction>

<cffunction name="createCKBox" access="public" returntype="void">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfscript>
		gMandatory=FALSE;
		gError=FALSE;
		tmpE=XMLSearch( MyXML, "element" );
		for (p=1; p LTE ArrayLen(tmpE); p++) {
			if ( stringToBoolean( tmpE[p].mandatory.XmlText ) ) gMandatory=TRUE;
			if ( THIS.eObj.isError( tmpE[p].key.XmlText ) ) gError=TRUE;
		}
	</cfscript>	

	<cfoutput>
    	<cfif gError>
            <ul class="error">
                <li>#createDot("error")# #createLabel(MyXML)#</li>
                #createCKBoxLine(tmpE)#
            </ul>
        <cfelse>
            <ul>
                <li><cfif gMandatory >#createDot("mandatory")#</cfif> #createLabel(MyXML)#</li>
                #createCKBoxLine(tmpE)#
            </ul>
    	</cfif>
	</cfoutput>

</cffunction>




</cfcomponent>