<cfcomponent 
	displayname="FORM base" 
	hint="costruttore di base sella FORM"
> 

<cfscript>init();</cfscript>

<cffunction name="dumpme" access="public" returntype="void">
	<cfargument name="my" type="any" required="yes">
	<cfdump var="#ARGUMENTS.my#">
</cffunction>

<!--- ESTERNE ---->
<cffunction name="refill" access="private" returntype="void">
</cffunction>

<!--- ESTERNE ---->
<cffunction name="myCK" access="private" returntype="void">
</cffunction>

<!--- ESTERNE ---->
<cffunction name="doSomething" access="private" returntype="void">
	FACCIO QUALCOSA <br />
	-----------------------------------------------------------------
	<cfdump var="#FORM#">
	-----------------------------------------------------------------
</cffunction>

<!--- ESTERNE ---->
<cffunction name="createForm" access="public" returntype="void">
	<cfargument name="myID" type="string" required="yes">
	<cfargument name="myLang" type="string" required="yes">

	<cfoutput>
		<div id="formWrapper">
			<cfform 		
				action="#SESSION.mixForms[ ARGUMENTS.myID ].getAction()#"  
				method="#SESSION.mixForms[ ARGUMENTS.myID ].getMethod()#" 
				enctype="multipart/form-data"
			>

				<!-- titolo -->
				<cfset tmpTitolo=SESSION.mixForms[ ARGUMENTS.myID ].getLabel()>
				<cfif tmpTitolo NEQ ""><H1>#tmpTitolo#</H1></cfif>
			
				<!-- errore -->
				<cfif NOT SESSION.mixForms.dataErrObj.errorFree() >
					<div id="mainError">#SESSION.mixForms.dataErrObj.getGeneralError()#</div>
				</cfif>

				<!-- linee -->
				#SESSION.mixForms[ ARGUMENTS.myID ].write( "nome" )#
				#SESSION.mixForms[ ARGUMENTS.myID ].write( "cognome" )#
				#SESSION.mixForms[ ARGUMENTS.myID ].write( "eta" )#
				#SESSION.mixForms[ ARGUMENTS.myID ].write( "cap" )#
				#SESSION.mixForms[ ARGUMENTS.myID ].write( "commento" )#
				#SESSION.mixForms[ ARGUMENTS.myID ].write( "immagine_1" )#

				<!--- CFdate: sporco ma non c'era scelta --->
				#SESSION.mixForms[ ARGUMENTS.myID ].writeHTMLpre( "date_1" )#
				<cfinput 
					type="datefield" 
					name="date_1" 
					id="date_1" 
					value="#SESSION.mixForms[ ARGUMENTS.myID ].getKeyVal( "date_1" )#" 
					daynames="#getDayNames( ARGUMENTS.myLang )#" 
					monthnames="#getMonthNames( ARGUMENTS.myLang )#" 
					mask="dd/mm/yyyy"
				>
				#SESSION.mixForms[ ARGUMENTS.myID ].writeHTMLpost( "date_1" )#

				<!--- CFcalendar: sporco ma non c'era scelta (non funziona) --->
<!---
				#SESSION.mixForms[ ARGUMENTS.myID ].writeHTMLpre( "date_2" )#
				<cfcalendar 
					name="date_2" 
					id="date_2" 
					daynames="#getDayNames( ARGUMENTS.myLang )#" 
					monthnames="#getMonthNames( ARGUMENTS.myLang )#" 
					firstDayOfWeek="1"
					mask="dd/mm/yyyy" 
					value="#SESSION.mixForms[ ARGUMENTS.myID ].getKeyVal( "date_2" )#" 
				>
				#SESSION.mixForms[ ARGUMENTS.myID ].writeHTMLpost( "date_2" )#
--->

				#SESSION.mixForms[ ARGUMENTS.myID ].writeHTMLpost( "rich_1" )#
				<cftextarea 
					name="rich_1" 
					id="rich_1"
					richtext="true" 
					toolbar="Basic"
				>#SESSION.mixForms[ ARGUMENTS.myID ].getKeyVal( "rich_1" )#</cftextarea>
				#SESSION.mixForms[ ARGUMENTS.myID ].writeHTMLpost( "rich_1" )#

				<label><input type="submit" name="Invia" id="Invia" value="Invia" /></label>
				<input class="hidden" type="hidden" id="Run" name="Run" value="#FORM.Run#" />
			</cfform>
		</div>
	</cfoutput>
</cffunction>


<!--- CFform HTML utils ------------------------------------------------------------------------->

<!--- 
	CFform: localizzazione lista giorni
--->
<cffunction name="getDayNames" access="public" returntype="string">
	<cfargument name="myLang" type="string" required="no">
	<cfscript>
		switch ( ARGUMENTS.myLang ) {
			case "en": myRet="S,M,T,W,T,F,S"; break;
			default: myRet="Do,Lu,Ma,Me,Gi,Ve,Sa"; break;
		}//END switch
		return( myRet );
	</cfscript>
</cffunction>

<!--- 
	CFform: localizzazione lista mesi
--->
<cffunction name="getMonthNames" access="public" returntype="string">
	<cfargument name="myLang" type="string" required="no">
	<cfscript>
		switch ( ARGUMENTS.myLang ) {
			case "en": myRet="January,february,March,April,May,June,July,August,September,October,November,December"; break;
			default: myRet="Gennaio,Febbraio,Marzo,Aprile,Maggio,Giugno,Luglio,Agosto,Settembre,Ottobre,Novembre,Dicembre"; break;
		}//END switch
		return( myRet );
	</cfscript>
</cffunction>




<cffunction name="run" access="public" returntype="void" output="yes">
	<cfargument name="myID" type="string" required="yes">
	<cfargument name="fileXML" type="string" required="yes">
	<cfargument name="myLang" type="string" required="yes">
	<cfargument name="myFL" type="string" required="yes">
	<cfargument name="debug" type="boolean" required="no" default="false">

	<cfparam name="FORM.Run" default="1st">

	<cfscript>
		// pulisce l'oggetto degli errori (mixCFC.mixform.utils.error.holder)
		SESSION.mixForms.dataErrObj.clearError();
		
		if ( ARGUMENTS.debug ) {
			dumpMe(FORM);
			SESSION.mixForms.sysErrObj.setDebugON();
		} else {
			// dovrebbe "silenziare " errori e warning di sistema (solo per produzione)
			// ma non funziona!!
			SESSION.mixForms.sysErrObj.setDebugOFF();
		}

		// se e' il primo passaggio, costruisce l'oggetto "form" e lo mette in SESSION
		if (FORM.Run EQ "1st") {
			//rigenera l'oggetto XML
			SESSION.mixForms[ ARGUMENTS.myID ] = createObject("component", "mixCFC.mixform.dataholder");
			SESSION.mixForms[ ARGUMENTS.myID ].setup( ARGUMENTS.myID, ARGUMENTS.fileXML, ARGUMENTS.myLang, ARGUMENTS.myFL );
			SESSION.mixForms[ ARGUMENTS.myID ].createDefaults();
			refill();
			FORM.Run = "get";
		}
		else {
			// riposta i valori FORM dentro i singoli oggetti LINE
			SESSION.mixForms[ ARGUMENTS.myID ].dropVals();
			// controlli standard
			SESSION.mixForms[ ARGUMENTS.myID ].runCK();
			// controlli NON standard (se ce ne sono)
			myCK();
			// se tutto OK, scrive
			if ( SESSION.mixForms.dataErrObj.errorFree() ) FORM.Run = "set";
		}
		
		// manda avanti la form
		switch ( FORM.Run ) {
			case "1st": createForm( ARGUMENTS.myID, ARGUMENTS.myLang ); break;
			case "get": createForm( ARGUMENTS.myID, ARGUMENTS.myLang ); break;
			case "set": doSomething(); break;
		} // end switch
	</cfscript>

</cffunction>



<!---
	COSTRUTTORE: carica il file xml con descrizione form e genera gli oggetti 
--->
<cffunction name="setup" access="public" returntype="void">
	<cfargument name="myID" type="string" required="yes">
	<cfargument name="myFile" type="string" required="yes">
	<cfargument name="myLang" type="string" required="yes">
	<cfargument name="myFL" type="string" required="yes">

	<cffile action="read" file="#MyFile#" variable="tmpFile">
	<cfscript>
		// legge XML e cancella il file per non occupare spazio
		fdXML=XMLParse(tmpFile, "no");
		tmpFile="";
		
		// crea oggetto params ed effettua tutti i controlli 
		paramObj=createObject("component", "mixCFC.mixform.elems.params");
		paramObj.setup( "pippo", THIS.fdXML.mixForm.params, ARGUMENTS.myLang, ARGUMENTS.myFL );
		linesObj=createObject("component", "mixCFC.mixform.elems.lines");
		linesObj.setup( THIS.fdXML.mixForm.lines, THIS.paramObj );
		blocksObj = createObject("component", "mixCFC.mixform.elems.blocks");
		blocksObj.setup( THIS.fdXML.mixForm.blocks, THIS.paramObj );

	</cfscript>
</cffunction>

<!---
COSTRUTTORE
--->
<cffunction name="init" access="private" returntype="void">
</cffunction>

</cfcomponent>