<cfcomponent 
	displayname="FORM base" 
	hint="costruttore di base della parte dati della FORM"
> 

<cfscript>init();</cfscript>

<cffunction name="dumpme" access="private" returntype="void">
	<cfargument name="my" type="any" required="yes">
	<cfdump var="#ARGUMENTS.my#">
</cffunction>


<!--- GETTER & SETTER (lines) ------------------------------------------------->

<cffunction name="getKeyVal" access="public" returntype="string">
	<cfargument name="myKey" type="string" required="yes">
	<cfscript>
		myRet=THIS.linesObj.getKeyVal( ARGUMENTS.myKey );
		return(myRet);
	</cfscript>
</cffunction>

<cffunction name="setKeyVal" access="public" returntype="void">
	<cfargument name="myKey" type="string" required="yes">
	<cfargument name="myVal" type="string" required="yes">
	<cfscript>
		THIS.linesObj.getKeyVal( ARGUMENTS.myKey, ARGUMENTS.myVal );
	</cfscript>
</cffunction>


<!--- GETTER (params) -------------------------------------------------------->

<cffunction name="getAction" access="public" output="no" returntype="string">
	<cfscript>
		// in mancanza di output="no" ridava " pippo.cfm" con uno spazio savanti ed imbarlava la form
		myRet=THIS.paramObj.getAction();
		return(myRet);
	</cfscript>
</cffunction>

<cffunction name="getMethod" access="public" output="no" returntype="string">
	<cfscript>
		// in mancanza di output="no" ridava " post" con uno spazio savanti ed imbarlava la form
		myRet=THIS.paramObj.getMethod();
		return(myRet);
	</cfscript>
</cffunction>

<cffunction name="getLabel" access="public" returntype="string">
	<cfscript>
		myRet=THIS.paramObj.getLabel();
		return(myRet);
	</cfscript>
</cffunction>

<!--- HTML (lines) --------------------------------------------------------->

<cffunction name="write" access="public" returntype="void">
	<cfargument name="myKey" type="string" required="yes">
	<cfscript>
		THIS.linesObj.write( ARGUMENTS.myKey );
	</cfscript>
</cffunction>

<cffunction name="writeHTMLpre" access="public" returntype="void">
	<cfargument name="myKey" type="string" required="yes">
	<cfscript>
		THIS.linesObj.writeHTMLpre( ARGUMENTS.myKey );
	</cfscript>
</cffunction>

<cffunction name="writeHTMLpost" access="public" returntype="void">
	<cfargument name="myKey" type="string" required="yes">
	<cfscript>
		THIS.linesObj.writeHTMLpost( ARGUMENTS.myKey );
	</cfscript>
</cffunction>


<!--- GROUP OPERATIONS ----------------------------------------------------->

<cffunction name="createDefaults" access="public" returntype="void">
	<cfscript>
		THIS.linesObj.createDefaults();
	</cfscript>
</cffunction>

<cffunction name="dropVals" access="public" returntype="void">
	<cfscript>
		THIS.linesObj.dropVals();
	</cfscript>
</cffunction>

<cffunction name="runCK" access="public" returntype="void">
	<cfscript>
		THIS.linesObj.runCK();
	</cfscript>
</cffunction>


<!--- COSTRUTTORE ---------------------------------------------------------->

<!---
	COSTRUTTORE: carica il file xml con descrizione form e genera gli oggetti 
--->
<cffunction name="setup" access="public" returntype="void">
	<cfargument name="myID" type="string" required="yes">
	<cfargument name="myFile" type="string" required="yes">
	<cfargument name="myLang" type="string" required="yes">
	<cfargument name="myFL" type="string" required="yes">

	<cffile action="read" file="#MyFile#" variable="tmpFile">
	<cfscript>
		// legge XML e cancella il file per non occupare spazio
		fdXML=XMLParse(tmpFile, "no");
		tmpFile="";
		
		// crea oggetto params ed effettua tutti i controlli 
		THIS.paramObj=createObject("component", "mixCFC.mixform.elems.params");
		THIS.paramObj.setup( "pippo", fdXML.mixForm.params, ARGUMENTS.myLang, ARGUMENTS.myFL );
		THIS.linesObj=createObject("component", "mixCFC.mixform.elems.lines");
		THIS.linesObj.setup( fdXML.mixForm.lines, THIS.paramObj );
		THIS.blocksObj = createObject("component", "mixCFC.mixform.elems.blocks");
		THIS.blocksObj.setup( fdXML.mixForm.blocks, THIS.paramObj );

	</cfscript>
</cffunction>

<!---
COSTRUTTORE
--->
<cffunction name="init" access="private" returntype="void">
</cffunction>

</cfcomponent>