<cfcomponent 
	displayname="baseBLOCK"
	hint="utility per la costruzione di tutti i blocchi"
>

<cfscript>init();</cfscript>

<cffunction name="dumpme" access="public" returntype="void">
	<cfargument name="MyVal" type="any" required="yes">
	<cfdump var="#ARGUMENTS.MyVal#">
</cffunction>


<!--- SETTER & GETTER ---------------------------------------------------------->

<!--- 
	SETTER & GETTER: val & key
---->
<cffunction name="isOK" access="public" returntype="boolean">
	<cfreturn THIS.ok> 
</cffunction>

<!--- UTILITY (private) -------------------------------------------------------->

<!--- 
	UTILITY: crea CKS xml valido ma vuoto, da passare quando manca nel file xml di descrizione della form
--->
<cffunction name="getNullCksXML" access="private" returntype="xml">
	<cfxml variable="MyVal" casesensitive="no"><cks /></cfxml>
	<cfreturn MyVal>
</cffunction>


<!--- 
	UTILITY: estrae NAME
--->
<cffunction name="extractName" access="private" returntype="string">
	<cfargument name="myXML" type="xml" required="yes">
	<cfreturn ARGUMENTS.myXML.XmlName>
</cffunction>


<!--- 
	UTILS: se c'e', estrae LABEL scegliendo la lingua 
---->
<cffunction name="extractLabel" access="private" returntype="string">
	<cfargument name="myXML" type="xml" required="yes">
	<cfargument name="mylang" type="string" required="yes">
	
	<cfscript>
		if ( isDefined("ARGUMENTS.myXML.label") ) {
			if ( isDefined( "ARGUMENTS.myXML.label." & ARGUMENTS.myLang ) ) 
				myLabel=ARGUMENTS.myXML.label[ ARGUMENTS.myLang ].XmlText;
			else
				myLabel="XML ERROR: BLOCK LABEL in language [" & ARGUMENTS.myLang & "] not found!";
		} else {
			SESSION.mixForms.sysErrObj.write("BLOCK LABEL undefined for block [" & THIS.name & "]");	
			myLabel="";	
		}
		return( myLabel );
	</cfscript>
	
</cffunction>


<!--- 
	UTILITY: estrae NEXT di un blocco
--->
<cffunction name="extractNext" access="private" returntype="string">
	<cfargument name="myXML" type="xml" required="yes">
	
	<cfscript>
		myRet="";
		if ( isDefined("ARGUMENTS.myXML.next") ) myRet = ARGUMENTS.myLineXML.next.Xmltext;
		else SESSION.mixForms.sysErrObj.write("Undefined NEXT in block [" & THIS.name & "]");
		return(MyRet);
	</cfscript>
	
</cffunction>

<!--- 
	UTILITY: estrae PREV di un blocco
--->
<cffunction name="extractPrev" access="private" returntype="string">
	<cfargument name="myXML" type="xml" required="yes">
	
	<cfscript>
		myRet="";
		if ( isDefined("ARGUMENTS.myXML.prev") ) myRet = ARGUMENTS.myLineXML.prev.Xmltext;
		else SESSION.mixForms.sysErrObj.write("Undefined PREV in block [" & THIS.name & "]");
		return(MyRet);
	</cfscript>
	
</cffunction>

<!--- 
	UTILITY: estrae LINELIST di un blocco
--->
<cffunction name="extractLineList" access="private" returntype="string">
	<cfargument name="myXML" type="xml" required="yes">
	
	<cfscript>
		myRet="";
		if ( isDefined("ARGUMENTS.myXML.linelist") ) {
			myRet = ARGUMENTS.myLineXML.linelist.Xmltext;
			if ( myRet IS "") SESSION.mixForms.sysErrObj.write("Empty LINELIST in block [" & THIS.name & "]");
		}
		else SESSION.mixForms.sysErrObj.write("Undefined NEXT in block [" & THIS.name & "]");
		return(MyRet);
	</cfscript>
	
</cffunction>


<!--- HTML (da scrivere) ---------------------------------------------------------->

<cffunction name="writeHTMLpre" access="public" returntype="void">
PRE
</cffunction>

<cffunction name="writeHTMLpost" access="public" returntype="void">
POST
</cffunction>


<!--- COSTRUTTORE ----------------------------------------------------------------->

<!---
	GESTIONE: sposta i dati dal file XML in esame allo scope THIS
--->
<cffunction name="setupBase" access="public" returntype="void">
	<cfargument name="myBaseXML" type="xml" required="yes">
	<cfargument name="myParams" type="any" required="yes">

	<cfscript>
		// copia i dati importati 
		THIS.lang = ARGUMENTS.myParams.getLang();
		THIS.FL = ARGUMENTS.myParams.getFL();

		writeCkObj=createObject("component", "mixCFC.mixform.utils.checks.write");
		//deve mandare a writeCkObj un XML valido per creare l'oggetto: se non lo ha manda quello vuoto di default
		if (NOT isDefined( "ARGUMENTS.myLineXML.write.cks" )) writeCkObj.setup( getNullCksXML(), THIS.lang, THIS.FL );
		else writeCkObj.setup( ARGUMENTS.myLineXML.write.cks, THIS.lang, THIS.FL );
		// esegue i controlli per decidere se crivere la riga
		THIS.ok = writeCkObj.runCKS();

		if ( THIS.ok ) {

			// inizia estrazione (dati OBBLIGATORI)
			THIS.name = ARGUMENTS.myBaseXML.XmlName;
			THIS.label = extractLabel( ARGUMENTS.myBaseXML, THIS.lang );
			THIS.prev = extractLabel( ARGUMENTS.myBaseXML, THIS.lang );
			THIS.next = extractLabel( ARGUMENTS.myBaseXML, THIS.lang );
			THIS.lineList = extractLabel( ARGUMENTS.myBaseXML, THIS.lang );
		}
	</cfscript>

</cffunction>


<!---
	COSTRUTTORE
--->
<cffunction name="init" access="private" returntype="void">
	<cfscript>
		// dati importati da fuori
		THIS.lang="";
		THIS.FL="";
		// questa dice se la linea esiste
		THIS.ok=FALSE;
		// dati
		THIS.name="";
		THIS.label="";
		THIS.next="";
		THIS.prev="";
		THIS.lineList="";
	</cfscript>
</cffunction>

</cfcomponent>