<cfcomponent 
	displayname="baseLINE"
	hint="utility per la costruzione di tutte le line e costruttore"
>

<cfscript>init();</cfscript>

<cffunction name="dumpme" access="public" returntype="void">
	<cfargument name="MyVal" type="any" required="yes">
	<cfdump var="#ARGUMENTS.MyVal#">
</cffunction>



<!--- SETTER & GETTER ---------------------------------------------------------->

<!--- 
	SETTER & GETTER: value & key
---->
<cffunction name="getValue" access="public" output="no" returntype="string">
	<cfscript>
		// tenere OUTPUT="no" altirmenti piazza spazi in giro
		// se non e' definto FORM, prende THIS.value che dovrebbe conetnere il valore di default
		// setta nache il valore aggiornato (che potrebbe essere un doppione di setval, ma non dovrebbe essere un problema
		if ( isDefined( "FORM." & THIS.key ) ) THIS.value=FORM[ THIS.key ];
		return(THIS.value); 
	</cfscript>
</cffunction>

<cffunction name="getKey" access="public" returntype="string">
	<cfreturn THIS.key> 
</cffunction>

<cffunction name="setValue" access="public" returntype="void">
	<cfargument name="my" type="string" required="yes">
	<cfset THIS.value = ARGUMENTS.my>
</cffunction>

<!--- 
	SETTER & GETTER: isOK (si puo' atampare la riga?)
---->
<cffunction name="isOK" access="public" returntype="boolean">
	<cfreturn THIS.ok> 
</cffunction>

<!--- UTILITY (private) -------------------------------------------------------->

<!--- 
	UTILS: da stringa a boolean 
--->
<cffunction name="stringToBoolean" access="private" returntype="boolean">
	<cfargument name="my" type="string" required="yes">
	
	<cfscript>
		switch( ARGUMENTS.my ) {
			case "ok": MyRet = TRUE; break;
			//nb: le due sotto fanno cast string -> boolean ed intercettano anche true/false
			case "yes": MyRet = TRUE; break;
			case "no": MyRet = FALSE; break;
			default: 
				MyRet = FALSE; 
				SESSION.mixForms.sysErrObj.write("string to be convented in Boolean is incorret: passed value [" & ARGUMENTS.MyVal & "]");
			break;
		}//END switch

		return(MyRet);
	</cfscript>
	
</cffunction>


<!--- 
	UTILS: crea CKS xml valido ma vuoto, da passare quando manca nel file xml di descrizione della form
--->
<cffunction name="getNullCksXML" access="private" returntype="xml">
	<cfxml variable="my" casesensitive="no"><cks /></cfxml>
	<cfreturn my>
</cffunction>


<!--- 
	UTILS: estrae MANDATORY da XML
--->
<cffunction name="extractMandatory" access="private" returntype="boolean">
	<cfargument name="myXML" type="xml" required="yes">

	<cfscript>
		myMandatory=FALSE;
		if ( isDefined("ARGUMENTS.myXML.write.mandatory") ) 
			myMandatory = stringToBoolean( ARGUMENTS.myXML.write.mandatory.Xmltext );
		else
			SESSION.mixForms.sysErrObj.write("Mandatory non definito", "warning");
		return( myMandatory );
	</cfscript>

</cffunction>


<!--- 
	UTILS: estrae HINT da XML (se c'e')
--->
<cffunction name="extractHint" access="private" returntype="boolean">
	<cfargument name="myXML" type="xml" required="yes">
	
	<cfscript>
		myRet=FALSE;
		if ( isDefined("ARGUMENTS.myXML.write.hint") ) 
			myRet = ARGUMENTS.myXML.write.hint.Xmltext;
		else
			SESSION.mixForms.sysErrObj.write("HINT non definito", "warning");
		return(MyRet);
	</cfscript>
	
</cffunction>


<!--- 
	UTILS: se c'e' estrae DAFAULT (per value) da XML
--->
<cffunction name="extractDefaultVal" access="private" output="no" returntype="string">
	<cfargument name="myXML" type="xml" required="yes">
	
	<cfscript>
		myRet="";
		if ( isDefined("ARGUMENTS.myXML.data.default") ) myRet = ARGUMENTS.myXML.data.default.Xmltext;
		return(MyRet);
	</cfscript>
	
</cffunction>


<!--- 
	UTILS: se i sono, estrae CHECKS sul dato 
--->
<cffunction name="extractDataChecks" access="private" returntype="xml">
	<cfargument name="myXML" type="xml" required="yes">
	
	<cfscript>
		if ( isDefined("ARGUMENTS.myXML.data.cks") ) myDC = ARGUMENTS.myXML.data.cks;
		else myDC = getNullCksXML();
		return( myDC );
	</cfscript>
	
</cffunction>


<!--- 
	UTILS: se c'e', estrae LABEL scegliendo la lingua 
--->
<cffunction name="extractLabel" access="private" returntype="string">
	<cfargument name="myXML" type="xml" required="yes">
	<cfargument name="mylang" type="string" required="yes">
	
	<cfscript>
		if ( isDefined( "ARGUMENTS.myXML." & ARGUMENTS.myLang ) ) 
			myLabel=ARGUMENTS.myXML[ ARGUMENTS.myLang ].XmlText;
		else
			myLabel="XML ERROR: LABEL in language [" & ARGUMENTS.myLang & "] not found!";
		return( myLabel );
	</cfscript>
	
</cffunction>

<!--- 
	UTILS: estrae il TYPE della riga (obbligatorio)
--->
<cffunction name="extractType" access="private" returntype="string">
	<cfargument name="myXML" type="xml" required="yes">
	
	<cfscript>
		myRet="";
		if ( isDefined("ARGUMENTS.myXML.write.type") ) {
			if ( isDefined("ARGUMENTS.myXML.write.type.XmlText") ) myRet = ARGUMENTS.myXML.write.type.Xmltext;
			else SESSION.mixForms.sysErrObj.write("line ["& THIS.key & "] TYPE defined in XML but empty");
		}
		else SESSION.mixForms.sysErrObj.write("line ["& THIS.key & "] TYPE non defined in XML");
		return(MyRet);
	</cfscript>
	
</cffunction>



<!--- HTML ---------------------------------------------------------->

<!--- 
	HTML: scrive il DOT in testa alla righe 
--->
<cffunction name="writeDot" access="private" returntype="string">
	<cfargument name="MyDotStyle" type="string" required="yes">
	<cfargument name="MyDot" type="string" required="yes">

	<cfscript>
		MyRet="";
		switch ( ARGUMENTS.MyDotStyle ) { 
			case "char": {
				switch ( ARGUMENTS.MyDot ) {
					case "error": MyRet="<span class=""dot"">!</span>"; break;
					case "mandatory": MyRet="<span class=""dot"">*</span>"; break;
					default: break;
				} //end stile "char"
				break;
			}
			case "empty": {
				switch ( ARGUMENTS.MyDot ) {
					case "error": MyRet="<span class=""dot""> </span>"; break;
					case "mandatory": MyRet="<span class=""dot""> </span>"; break;
					default: break;
				} //end stile "empty"
				break;
			}
			default: {
				switch ( ARGUMENTS.MyDot ) {
					case "error": MyRet="<span class=""dot""> </span>"; break;
					case "mandatory": MyRet="<span class=""dot""> </span>"; break;
					default: break;
				} //end stile "default"
				break;
			}
		}//FINE switch esterno
		return(MyRet);
	</cfscript>

</cffunction>


<!--- 
	HTML: scrive il DOT in testa alla righe 
--->
<cffunction name="writeHint" access="private" returntype="string">

	<cfif THIS.hint NEQ ""><span class="hint">#ARGUMENTS.myHint#</span></cfif>

</cffunction>


<!--- 
	HTML: scrive la parte di HTML che precede riga di input; segue il modello dell'HTML definitivo

	<label id="myForm_pippo" class="error">
		<span class="dot">!</span>
		Immetti il tuo nome
		<span class="message">C'e' QUESTO errore</span>
		<input type="text" name="pippo" id="pippo" value="-2">
		<span class="hint">Deve essere un nome italiano!</hint>
	</label>

--->
<cffunction name="writeHTMLpre" access="public" returntype="void">

	<cfoutput>
		
		<cfif SESSION.mixForms.dataErrObj.isError( THIS.key ) >
			<label id="myForm_#THIS.key#" class="error">
				#writeDot(THIS.dotStyle, "error")# 
				#THIS.label# 
				<span class="message">#SESSION.mixForms.dataErrObj.getError( THIS.key )#</span>
		<cfelse>
			<cfif THIS.mandatory >
				<label id="myForm_#THIS.key#">
					#writeDot(THIS.dotStyle, "mandatory")#
					#THIS.label# 
			<cfelse>
				<label id="myForm_#THIS.key#">
					#THIS.label#
			</cfif>
		</cfif>

	</cfoutput>
</cffunction>


<!--- 
	HTML: scrive la parte di HTML che segue la riga di input
--->
<cffunction name="writeHTMLpost" access="public" returntype="void">

	<cfoutput>
			#writeHint()#
		</label>
	</cfoutput>
</cffunction>




<!--- COSTRUTTORE ----------------------------------------------------------------->

<!---
	GESTIONE: esegue i controlli
--->
<cffunction name="dataCK" access="public" returntype="void">
	<cfscript>
		THIS.dataCkObj.runCKS( THIS.value, THIS.key );
	</cfscript>
</cffunction>


<!---
	GESTIONE: sposta i dati dal file XML in esame allo scope THIS
--->
<cffunction name="setupBase" access="public" returntype="void">
	<cfargument name="myLineXML" type="xml" required="yes">
	<cfargument name="myParams" type="any" required="yes">


	<cfscript>
		// copia i dati importati 
		THIS.lang = ARGUMENTS.myParams.getLang();
		THIS.FL = ARGUMENTS.myParams.getFL();
		THIS.dotStyle = ARGUMENTS.myParams.getDotStyle();

		writeCkObj=createObject("component", "mixCFC.mixform.utils.checks.write");
		//deve mandare a writeCkObj un XML valido per creare l'oggetto: se non lo ha manda quello vuoto di default
		if (NOT isDefined( "ARGUMENTS.myLineXML.write.cks" )) writeCkObj.setup( getNullCksXML(), THIS.lang, THIS.FL );
		else writeCkObj.setup( ARGUMENTS.myLineXML.write.cks, THIS.lang, THIS.FL );
		// esegue i controlli per decidere se crivere la riga
		THIS.ok = writeCkObj.runCKS();

		// inizia estrazione (dati OBBLIGATORI)
		// non sarebbero strettamentre necessari se THIS.ok=FALSE, ma se non ci sono fanno casino nella mella getkey
		THIS.key = ARGUMENTS.myLineXML.XmlName;
		THIS.type = extractType( ARGUMENTS.myLineXML );
		THIS.label = extractLabel( ARGUMENTS.myLineXML.write.label, THIS.lang );

		if ( THIS.ok ) {

			
			// inizia estrazione (dati FACOLTATIVI, ma che potenzialmente hanno tutti)
			THIS.mandatory = extractMandatory( ARGUMENTS.myLineXML );
			THIS.value = extractDefaultVal( ARGUMENTS.myLineXML );

			//writeOutput("SCELGO OGGETTO CKS per " & THIS.key & "<br />"); //DEBUG
			//dumpme(extractDataChecks( ARGUMENTS.myLineXML ));//DEBUG
			
			// deve mandare a dataCkObj un XML valido per creare l'oggetto
			// se ne occupa "extractDataChecks" eventualmente di mandare quello vuoto di default
			THIS.dataCkObj.setup( extractDataChecks( ARGUMENTS.myLineXML ), THIS.lang, THIS.FL );

			//dumpme(THIS.dataCkObj);//DEBUG
			//writeOutput("FINE SCELGO OGGETTO CKS per " & THIS.key & "<br />"); //DEBUG
			//writeOutput("---------------------------------------------------------------------<br />"); //DEBUG
		}
	</cfscript>

</cffunction>


<!---
	COSTRUTTORE
--->
<cffunction name="init" access="private" returntype="void">
	<cfscript>
		THIS.dataCkObj=createObject("component", "mixCFC.mixform.utils.checks.data");
		// dati importati da fuori
		THIS.lang="";
		THIS.FL="";
		THIS.dotStyle="";
		// questa dice se la linea esiste
		THIS.ok=FALSE;
		// dati
		THIS.mandatory="";
		THIS.type="";
		THIS.label="";
		THIS.key="";
		THIS.value="";
		THIS.hint="";
	</cfscript>
</cffunction>

</cfcomponent>