<cfcomponent 
	extends="base" 
	hint="Crea una SELECT popolandola con i file di una directory"
>

<!--- 
	GETTER & SETTER: dir
--->
<cffunction name="getPath" access="public" returntype="string">
	<cfreturn THIS.path>
</cffunction>

<!--- 
	UTILITY: se c'e' estrae PATH da XML e lo elabora per farlo divetare fully qualyfied
--->
<cffunction name="extractPath" access="private" returntype="string">
	<cfargument name="myXML" type="xml" required="yes">
	
	<cfscript>
		myRet="";
		// se e' definita la directory in cui si trova application
		if ( isDefined("SESSION.ApplicationDir") ) myRet=SESSION.ApplicationDir;
		else SESSION.mixForms.sysErrObj.write("UNDEFINED SESSION.ApplicationDir", "warning");	

		if ( isDefined("ARGUMENTS.myXML.data.path") ) myRet=myRet & ARGUMENTS.myXML.data.path.XmlText;
		else SESSION.mixForms.sysErrObj.write("PATH in sundefined for key [" & THIS.key & "]", "warning");	

		return(MyRet);
	</cfscript>
	
</cffunction>


<!--- 
	HTML: controlla la diorectory e genera la select con i nomi dei file
--->
<cffunction name="directoryToSelect" access="private" returntype="void" >

	<cfdirectory directory="#THIS.path#" action="list" recurse="no" sort="name" listInfo="name" name="myQr" type="file">
	<cfoutput><select name="#THIS.key#"></cfoutput>
		<cfoutput query="myQr">
			<cfset mySelected="">
			<cfif FORM[ THIS.key ] EQ name><cfset mySelected="selected=""selected"""></cfif>
			<option value="#name#" #mySelected#>#name#</option>
		</cfoutput>
	</select>

</cffunction>


<!--- DEFOULT OBJECT ---------------------------------------------------------------->

<!--- 
	HTML: crea una linea INPUT STANDARD 
--->
<cffunction name="write" access="public" returntype="void">


	<cfif THIS.ok>
		<cfoutput>
			#writeHTMLpre()#
			#directoryToSelect()#
			#writeHTMLpost()#
		</cfoutput>
	</cfif>
	
</cffunction>


<!--- 
	UTILS: chiama la build e fa le "estrazioni" di base
--->
<cffunction name="setup" access="public" returntype="void">
	<cfargument name="myLineXML" type="xml" required="yes">
	<cfargument name="myParams" type="any" required="yes">

	<cfscript>
		setupBase( ARGUMENTS.myLineXML, ARGUMENTS.myParams );
		// se si devono fare altre estrazioni, questo e' il momento
		THIS.path=extractPath( ARGUMENTS.myLineXML );
	</cfscript>

</cffunction>

</cfcomponent>
