<cfcomponent 
	displayname="Lines" 
	hint="container di oggetti 'line' e esecutore di operazioni di gruppo"
> 

<cfscript>init();</cfscript>

<!--- 
	DEBUG: dumpeme
--->
<cffunction name="dumpme" access="public" returntype="string">
	<cfargument name="my" type="any" required="yes">
	<cfdump var="#ARGUMENTS.my#">
</cffunction>

<!--- GROUP ACTION --------------------------------------------------------------------->

<!---
	UTILS: Create Defaults scorre la struct di oggetti linea e cerca i valori di default
--->
<cffunction name="createDefaults" access="public" returntype="void">
	<cfscript>
		objList=StructKeyList(THIS.lines);
		for (oi=1; oi LTE listLen(objList); oi++) {
			tmpObjName = listGetAt(objList, oi);
			if ( THIS.lines[ tmpObjName ].isOK() )
				// crea i default in FORM solo per le linne da stampare 
				FORM[ tmpObjName ] = THIS.lines[ tmpObjName ].getValue();
		}
	</cfscript>
</cffunction>

<!---
	UTILS: DROPVALS porta i valori da FORM a oggetti linea
--->
<cffunction name="dropVals" access="public" returntype="void">
	<cfscript>
		objList=StructKeyList(THIS.lines);
		for (oi=1; oi LTE listLen(objList); oi++) {
			tmpObjName = listGetAt(objList, oi);
			if ( THIS.lines[ tmpObjName ].isOK() )
				// esegue i controlli solo per le righe presenti 
				THIS.lines[ tmpObjName ].setValue( FORM[ tmpObjName ] );
		}
	</cfscript>
</cffunction>


<!---
	UTILS: esegue controlli: scorre la struct di oggetti linea e esegue i controlli standard
--->
<cffunction name="runCK" access="public" returntype="void">
	<cfscript>
		objList=StructKeyList(THIS.lines);
		objLen=listLen(objList);
		for (oi=1; oi LTE objLen; oi++) {
			tmpObjName = listGetAt(objList, oi);
			THIS.lines[ tmpObjName ].dataCK();
		}
	</cfscript>
</cffunction>

<!--- GETTER & SETTER --------------------------------------------------------->

<cffunction name="getKeyVal" access="public" returntype="string">
	<cfargument name="myKey" type="string" required="yes">
	<cfscript>
		myRet=THIS.lines[ ARGUMENTS.myKey ].getValue();
		return( myRet );
	</cfscript>
</cffunction>

<cffunction name="setKeyVal" access="public" returntype="void">
	<cfargument name="myKey" type="string" required="yes">
	<cfargument name="myVal" type="string" required="yes">
	<cfscript>
		THIS.lines[ ARGUMENTS.myKey ].setValue();
	</cfscript>
</cffunction>

<!--- HTML --------------------------------------------------------------------->
<cffunction name="write" access="public" returntype="void">
	<cfargument name="myKey" type="string" required="yes">
	<cfscript>
		THIS.lines[ ARGUMENTS.myKey ].write();
	</cfscript>
</cffunction>

<cffunction name="writeHTMLpre" access="public" returntype="void">
	<cfargument name="myKey" type="string" required="yes">
	<cfscript>
		THIS.lines[ ARGUMENTS.myKey ].writeHTMLpre();
	</cfscript>
</cffunction>

<cffunction name="writeHTMLpost" access="public" returntype="void">
	<cfargument name="myKey" type="string" required="yes">
	<cfscript>
		THIS.lines[ ARGUMENTS.myKey ].writeHTMLpost();
	</cfscript>
</cffunction>




<!---
	COSTRUTTORE
--->
<cffunction name="setup" access="public" returntype="void">
	<cfargument name="myXML" type="xml" required="yes">
	<cfargument name="myParams" type="any" required="yes">

	<cfscript>
		myArray=ARGUMENTS.myXML.XmlChildren;
		mylen=arrayLen(myArray);
		for(k=1; k LTE myLen; k++) {
			myName = myArray[k].XmlName; 
			myType = myArray[k].write.type.XmlText; 

			switch( myType ) {

				// ELEMENTI HTML --------------------------
				case "input": THIS.lines[ myName ] = createObject("component", "mixCFC.mixform.elems.line.input"); break;
				case "fileChooser": THIS.lines[ myName ] = createObject("component", "mixCFC.mixform.elems.line.fileChooser"); break;
				case "password": THIS.lines[ myName ] = createObject("component", "mixCFC.mixform.elems.line.password"); break;
				case "selectFromDirectory": THIS.lines[ myName ] = createObject("component", "mixCFC.mixform.elems.line.selectFromDirectory"); break;
				
				// ELEMENTI CFFORM --------------------------
				case "CFcalendar": THIS.lines[ myName ] = createObject("component", "mixCFC.mixform.elems.line.CFcalendar"); break;
				case "CFdate": THIS.lines[ myName ] = createObject("component", "mixCFC.mixform.elems.line.CFdate"); break;
				case "CFrichText": THIS.lines[ myName ] = createObject("component", "mixCFC.mixform.elems.line.CFrichText"); break;
				
				default:
					SESSION.mixForms.sysErrObj.write("LINE [" & myName & "] TYPE provided [" & myType & "] is unknown");	
				break;
			}//END switch

			// con questo controllo solo le righe che devono effettivamente essere stampate vengono salvate
			// si risparmierebbe memoria in SESSION 
			// al momemnto non lo facciamo
			// if ( tmpObj.isOK() ) THIS[ myName ] = tmpObj;
			THIS.lines[ myName ].setup( myArray[k], ARGUMENTS.myParams );
			//dumpme(THIS.lines); //debug
			//writeOutput("--------------------------------------------------------<br />"); //debug
		}
	</cfscript>
	
</cffunction>

<!---
	COSTRUTTORE
--->
<cffunction name="init" access="private" returntype="void">
	<cfscript>
		THIS.lines=structNew();
	</cfscript>
</cffunction>

</cfcomponent>