<cfcomponent
	displayname="PARAMS" 
	hint="Estrae i parametri dal file XML e crea una struttura dove incapsularli, in modo da non dover ripetere il parse piu' volte" 
>

<cfscript>init();</cfscript>

<!--- 
	DEBUG: stampa un dump da cfscript
--->
<cffunction name="dumpme" access="public" returntype="void"> 
	<cfargument name="x" type="any" required="yes">
	<cfdump var="#x#">
</cffunction>


<!--- GETTER & SETTER --------------------------------------------------->

<!--- 
	IS: controlla che i params riano stati processati senza errori
--->
<cffunction name="isOK" access="public" returntype="string"> 
	<cfreturn THIS.ok>
</cffunction>

<!--- 
	GETTER & SETTER: ID
--->
<cffunction name="getID" access="public" returntype="string"> 
	<cfreturn THIS.ID>
</cffunction>

<cffunction name="setID" access="private" returntype="void"> 
	<cfargument name="myVal" type="string" required="yes">

	<cfscript>
		if ( ARGUMENTS.myVal IS "" ) SESSION.mixForms.sysErrObj.write("Missing ID: ID is empty");
		else THIS.ID = ARGUMENTS.myVal;
	</cfscript>
	
</cffunction>

<!--- 
	GETTER & SETTER: LANG e default LANG
--->
<cffunction name="getLang" access="public" returntype="string"> 
	<cfreturn THIS.lang>
</cffunction>

<cffunction name="setLang" access="private" returntype="void"> 
	<cfargument name="myVal" type="string" required="yes">
	
	<cfscript>
		// se scrive lang per la prima volta
		switch ( len(ARGUMENTS.myVal) ) {
			case "0": SESSION.mixForms.sysErrObj.write( "Selected LANG il empty, will try to use default", "warning" ); break;
			case "2": THIS.lang = ARGUMENTS.myVal; break;
			default: 
				SESSION.mixForms.sysErrObj.write( "Selected LANG [" & ARGUMENTS.myVal & "] is INVALID, will try to use default" );
			break;
		}//END switch
	</cfscript>
	
</cffunction>

<cffunction name="setDefaultLang" access="private" returntype="void"> 
	<cfargument name="myVal" type="string" required="yes">
	
	<cfscript>
		if (  THIS.lang NEQ "" ) 
			// ha gia' un lang valido
			SESSION.mixForms.sysErrObj.write( "Already got valid lang [" & THIS.lang & "], will ignore defaultLang [" & ARGUMENTS.myVal & "]", "warning" );
		else {
			// non c'e' lang valido: controlla default	
			switch ( len(ARGUMENTS.myVal) ) {
				case "0": SESSION.mixForms.sysErrObj.write( "Default LANG il empty: no valid LANG foud at all"); break;
				case "2": THIS.lang = ARGUMENTS.myVal; break;
				default: 
					SESSION.mixForms.sysErrObj.write( "Default LANG [" & ARGUMENTS.myVal & "] is INVALID, no valid LANG foud at all" );
				break;
			}//END switch
		}
	</cfscript>
	
</cffunction>


<!--- 
	GETTER & SETTER: LABEL
--->
<cffunction name="getLabel" access="public" returntype="string"> 
	<cfreturn THIS.label>
</cffunction>

<cffunction name="setLabel" access="private" returntype="void"> 
	<cfargument name="myVal" type="string" required="yes">
	<cfset THIS.label=ARGUMENTS.myVal>
</cffunction>


<!--- 
	GETTER & SETTER: ACTION
--->
<cffunction name="getAction" access="public" output="no" returntype="string"> 
	<!--- in mancanza di output="no" ridava " pippo.cfm" con uno spazio savanti ed imbarlava la form --->
	<cfreturn THIS.action>
</cffunction>

<cffunction name="setAction" access="private" returntype="void"> 
	<cfargument name="myVal" type="string" required="yes">

	<cfscript>
		if ( ARGUMENTS.myVal IS "" ) SESSION.mixForms.sysErrObj.write("ACTION is empty");
		else THIS.action = ARGUMENTS.myVal;
	</cfscript>
	
</cffunction>


<!--- 
	GETTER & SETTER: METHOD
--->
<cffunction name="getMethod" access="public" output="no" returntype="string"> 
	<!--- in mancanza di output="no" ridava " post" con uno spazio savanti ed imbarlava la form --->
	<cfreturn THIS.Method>
</cffunction>

<cffunction name="setMethod" access="private" returntype="void"> 
	<cfargument name="myVal" type="string" required="yes">
	
	<cfscript>
		switch( ARGUMENTS.myVal ) {
			case "post": THIS.method="post"; break;
			case "get": THIS.method="get"; break;
			case "": 
				SESSION.mixForms.sysErrObj.write("METHOD in empty - using default POST", "warning");	
				THIS.method="post"; 
			break;
			default: 
				SESSION.mixForms.sysErrObj.write("METHOD [" & ARGUMENTS.myVal & "] is invalid, using default POST", "warning");	
				THIS.method="post"; 
			break;
		}//END Switch
	</cfscript>
	
</cffunction>


<!--- 
	GETTER & SETTER: DOTSTYLE
--->
<cffunction name="getDotStyle" access="public" returntype="string"> 
	<cfreturn THIS.dotStyle>
</cffunction>

<cffunction name="setDotStyle" access="private" returntype="void"> 
	<cfargument name="myVal" type="string" required="yes">
	
	<cfscript>
		switch( ARGUMENTS.myVal ) {
			case "char": THIS.dotStyle="char"; break;
			case "": 
				SESSION.mixForms.sysErrObj.write("DOTSTYLE empty: using default CHAR", "warning");	
				THIS.dotStyle="char"; 
			break;
			default: 
				SESSION.mixForms.sysErrObj.write("DOTSTYLE [" & ARGUMENTS.myVal & "] is invalid: using default CHAR", "warning");	
				THIS.dotStyle="char"; 
			break;
		}//END Switch
	</cfscript>
	
</cffunction>


<!--- 
	GETTER & SETTER: DEFAULTDS
--->
<cffunction name="getDefaultDS" access="public" returntype="string"> 
	<cfreturn THIS.defaultDS>
</cffunction>

<cffunction name="setDefaultDS" access="private" returntype="void"> 
	<cfargument name="myVal" type="string" required="yes">
	
	<cfscript>
		if ( ARGUMENTS.myVal IS "" ) SESSION.mixForms.sysErrObj.write("DATASOURCE is empty", "warning");
		THIS.defaultDS = ARGUMENTS.myVal;
	</cfscript>
	
</cffunction>


<!--- 
	GETTER & SETTER: FL
--->
<cffunction name="setFL" access="private" returntype="void"> 
	<cfargument name="myVal" type="string" required="yes">
	<cfset THIS.FL = ARGUMENTS.myVal >
</cffunction>

<cffunction name="getFL" access="public" returntype="string"> 
	<cfreturn THIS.FL>
</cffunction>


<!--- 
	GETTER & SETTER: blocktype
--->
<cffunction name="getBlockType" access="public" returntype="string"> 
	<cfreturn THIS.blockType>
</cffunction>

<cffunction name="setBlockType" access="private" returntype="void"> 
	<cfargument name="myVal" type="string" required="yes">
	
	<cfscript>
		switch( ARGUMENTS.myVal ) {
			case "lose": THIS.blockType="lose"; break;
			case "strict": THIS.blockType="strict"; break;
			case "": 
				SESSION.mixForms.sysErrObj.write("BLOCK TYPE empty: using default LOSE", "warning");	
				THIS.blockType="lose";
			break;
			default: 
				SESSION.mixForms.sysErrObj.write("DOTSTYLE [" & ARGUMENTS.myVal & "] is invalid: using default LOSE", "warning");	
				THIS.blockType="lose";
			break;
		}//END Switch
	</cfscript>
	
</cffunction>


<!--- 
	GETTER & SETTER: blockfocus
--->
<cffunction name="getBlockFocus" access="public" returntype="string"> 
	<cfreturn THIS.blockFocus>
</cffunction>

<cffunction name="setBlockFocus" access="private" returntype="void"> 
	<cfargument name="myVal" type="string" required="yes">

	<cfscript>
		if ( ARGUMENTS.myVal IS "" ) SESSION.mixForms.sysErrObj.write("BLOCKFOCUS is empty");
		else THIS.blockFocus = ARGUMENTS.myVal;
	</cfscript>
	
	
</cffunction>


<!--- EXTRACT ----------------------------------------------------------->

<!--- 
	UTILS: estrae LANG dal file XML
--->
<cffunction name="extractDefaultLang" access="private" returntype="void"> 
	<cfargument name="myXML" type="xml" required="yes">

	<cfscript>
		if ( NOT isDefined("ARGUMENTS.myXML.default.lang") ) SESSION.mixForms.sysErrObj.write( "Dafault LANG key missing" );
		else setDefaultLang( ARGUMENTS.myXML.default.lang.xmlText );
	</cfscript>

</cffunction>


<!--- 
	UTILS: estrae LABEL dal file XML
--->
<cffunction name="extractLabel" access="private" returntype="void"> 
	<cfargument name="myXML" type="xml" required="yes">

	<cfscript>
		// controlla che ci sia la LABEL
		if ( NOT isDefined("ARGUMENTS.myXML.write.label" ) ) SESSION.mixForms.sysErrObj.write("missing FORM label");	
		else {
			// controlla che per quel LANG ci sia la label 
			if ( NOT isDefined("ARGUMENTS.myXML.write.label." & THIS.lang ) ) 
				SESSION.mixForms.sysErrObj.write("missing FORM label for language [" & THIS.lang & "]");	
			else setLabel( ARGUMENTS.myXML.write.label[ THIS.lang ].XmlText );
		}
	</cfscript>

</cffunction>


<!--- 
	UTILS: estrae ACTION dal file XML
--->
<cffunction name="extractAction" access="private" returntype="void"> 
	<cfargument name="myXML" type="xml" required="yes">

	<cfscript>
		// controlla che ci sia ACTION e non sia vuoto 
		if ( NOT isDefined("ARGUMENTS.myXML.write.action" ) ) SESSION.mixForms.sysErrObj.write("missing ACTION key");	
		else setAction( ARGUMENTS.myXML.write.action.XmlText );
	</cfscript>

</cffunction>


<!--- 
	UTILS: estrae METHOD dal file XML
--->
<cffunction name="extractMethod" access="private" returntype="void"> 
	<cfargument name="myXML" type="xml" required="yes">

	<cfscript>
		// controlla che ci sia METHOD e non sia valido
		if ( NOT isDefined("ARGUMENTS.myXML.write.method" ) ) {
			SESSION.mixForms.sysErrObj.write("METHOD key missing, using default POST", "warning");	
			setMethod( "post" );
		}
		else setMethod( ARGUMENTS.myXML.write.method.XmlText );
	</cfscript>

</cffunction>


<!--- 
	UTILS: estrae DOTSTYLE dal file XML
--->
<cffunction name="extractDotStyle" access="private" returntype="void"> 
	<cfargument name="myXML" type="xml" required="yes">

	<cfscript>
		// controlla che ci sia DOT e non sia vuoto
		if ( NOT isDefined("ARGUMENTS.myXML.write.dotStyle" ) ) {
			SESSION.mixForms.sysErrObj.write("missing DOTSTYLE key: using default CHAR", "warning");	
			setDotStyle( "char" );
		}
		else setDotStyle( ARGUMENTS.myXML.write.dotStyle.XmlText );
	</cfscript>

</cffunction>


<!--- 
	UTILS: estrae DEFAULTDS dal file XML
--->
<cffunction name="extractDefaultDS" access="private" returntype="void"> 
	<cfargument name="myXML" type="xml" required="yes">

	<cfscript>
		// controlla che ci sia DATASOURCE 
		if ( NOT isDefined("ARGUMENTS.myXML.default.datasource" ) ) SESSION.mixForms.sysErrObj.write("missing DATASOURCE key", "warning");	
		else setDefaultDS( ARGUMENTS.myXML.default.datasource.XmlText ); 
	</cfscript>

</cffunction>


<!--- 
	UTILS: estrae BLOCK TYPE dal file XML
--->
<cffunction name="extractBlockType" access="private" returntype="void"> 
	<cfargument name="myXML" type="xml" required="yes">

	<cfscript>
		// controlla che ci sia la key e che non sia vuota; setta default
		if ( NOT isDefined("ARGUMENTS.myXML.blocks.type" ) ) {
			SESSION.mixForms.sysErrObj.write("missing BLOCKTYPE key: usign deafutl LOSE", "warning");	
			setBlockType( "lose" );
		}
		else setBlockType( ARGUMENTS.myXML.blocks.type.XmlText ); 
	</cfscript>

</cffunction>

<!--- 
	UTILS: estrae BLOCK FOCUS dal file XML
--->
<cffunction name="extractBlockFocus" access="private" returntype="void"> 
	<cfargument name="myXML" type="xml" required="yes">

	<cfscript>
		// controlla che ci sia la key
		if ( NOT isDefined("ARGUMENTS.myXML.blocks.focus" ) ) SESSION.mixForms.sysErrObj.write("missing BLOCKFOCUS key");	
		else setBlockFocus( ARGUMENTS.myXML.blocks.focus.XmlText ); 
	</cfscript>

</cffunction>


<!--- 
	COSTRUTTORE: estrae BLOCK FOCUS dal file XML
--->
<cffunction name="setup" access="public" returntype="void"> 
	<cfargument name="myID" type="string" required="yes">
	<cfargument name="myXML" type="xml" required="yes">
	<cfargument name="myLang" type="string" required="yes">
	<cfargument name="myFL" type="string" required="yes">
	
	<cfscript>
		// resatta oggetto errori sistema
		SESSION.mixForms.sysErrObj.reset();

		// setta i parametri di base
		setID( ARGUMENTS.myID );
		setLang( ARGUMENTS.myLang );
		setFL( ARGUMENTS.myFL );
		
		//estrae gli altri da XML 
		extractDefaultLang( ARGUMENTS.myXML );
		extractLabel( ARGUMENTS.myXML );
		extractAction( ARGUMENTS.myXML );
		extractMethod( ARGUMENTS.myXML );
		extractDotStyle( ARGUMENTS.myXML );
		extractDefaultDS( ARGUMENTS.myXML );
		extractBlockType( ARGUMENTS.myXML );
		extractBlockFocus( ARGUMENTS.myXML );
		
		// controlla errori sistema
		THIS.ok = SESSION.mixForms.sysErrObj.isOK();
	</cfscript>
	
</cffunction>


<!--- 
	COSTRUTTORE: mette valori default
--->
<cffunction name="init" access="public" returntype="void">

	<cfscript>
		// starus oggetto
		THIS.ok=TRUE;
		// gestione oggetto
		THIS.ID="";
		THIS.lang="";
		THIS.label="";
		THIS.action="";
		THIS.method="";
		THIS.dotStyle="";
		THIS.defaultDS="";
		THIS.blockType="";
		THIS.blockFocus="";
		THIS.FL="";
	</cfscript>
	
</cffunction>



</cfcomponent>