<cfcomponent 
	displayname="dataChecks" 
	extends="base" 
	hint="esefue i controlli per vedere se un dato di una linea e' conforme"
>

<!--- 
	UTILS: per milgiorare la leggibilita', non ha altro scopo
--->
<cffunction name="addDataError" access="private" returntype="boolean" output="no">
	<cfargument name="myKey" type="string" required="yes">
	<cfargument name="myPath" type="string" required="yes">

	<cfscript>
		SESSION.mixForms.dataErrObj.addErrorFromXML(ARGUMENTS.myKey, ARGUMENTS.myPath);
		return(FALSE);
	</cfscript>
	
</cffunction>


<!--- 
	CK: controlla un CODICE FISCALE 
--->
<cffunction name="isCF" access="private" returntype="boolean" output="no">

	<cfscript>
		myErr = TRUE;
		if ( len(THIS.value) IS 16 ) {
			if ( REFindNoCase("[a-zA-Z0-9]{16}", THIS.value, 1 ) NEQ 1) myErr = addDataError( THIS.key, "errori/cf/caratteriErrati" );
			if ( REFindNoCase("[a-zA-Z]{6}", Left( THIS.value, 6), 1 ) NEQ 1) myErr = addDataError( THIS.key, "errori/cf/nonValido" );
			// qui bisogna inserire il controllo mancantne 
			// if (  ) addDataError(THIS.key, "errori/cf/nonValido");
		}
		else {
			if ( len(THIS.value) LT 16 ) myErr = addDataError( THIS.key, "errori/cf/corto" );
			if ( len(THIS.value) GT 16 ) myErr = addDataError( THIS.key, "errori/cf/lungo" );
		}
		return( myErr );
	</cfscript>

</cffunction>


<!--- 
	CK: controlla PARTITA IVA 
--->
<cffunction name="isIVA" access="private" returntype="boolean" output="no">

	<cfscript>
		myErr = TRUE;
		if ( len(THIS.value) IS 11 ) {
			if ( REFindNoCase("[0-9]{11}", THIS.value, 1 ) NEQ 1) myErr = addDataError( THIS.key, "errori/iva/caratteriErrati" );
			// qui bisogna inserire il controllo mancante 
			// if ( ) myErr = addDataError(THIS.key, "errori/iva/nonValido");
		}
		else {
			if ( len(THIS.value) LT 11 ) myErr = addDataError( THIS.key, "errori/iva/corto" );
			if ( len(THIS.value) GT 11 ) myErr = addDataError( THIS.key, "errori/iva/lungo" );
		}
		return( myErr );
	</cfscript>

</cffunction>


<!--- CK: 
	controlla PARTITA IVA or CF 
--->
<cffunction name="isIVAorCF" access="private" returntype="boolean" output="yes">

	<cfscript>
		myErr = TRUE;
		switch ( len(THIS.value) ) {

			case "11": 
				// controlla la partita IVA
				if ( REFindNoCase("[0-9]{11}", THIS.value, 1 ) NEQ 1) {
					myErr = addDataError( THIS.value, "errori/ivaOrCf/caratteriErratiIVA" );
					// qui bisogna inserire il controllo mancante 
					// if ( ) myErr = addDataError(THIS.key, "errori/iva/nonValido");
				}
			break;

			case "16":
				// controlla il codice fiscale
				if ( REFindNoCase("[a-zA-Z0-9]{16}", THIS.value, 1 ) NEQ 1) myErr = addDataError( THIS.key, "errori/ivaOrCf/caratteriErratiCF" );
				if ( REFindNoCase("[a-zA-Z]{6}", Left( THIS.value, 6), 1 ) NEQ 1) myErr = addDataError( THIS.key, "errori/ivaOrCf/nonValido" );
				// qui bisogna inserire il controllo mancantne 
				// if (  ) myErr = addDataError(THIS.value, "errori/cf/nonValido");
			break;

			default: 
				// gestisce tutti i casi "troppo lungo / troppo corto"
				if ( len(THIS.value) LT 11 ) myErr = addDataError( THIS.key, "errori/ivaOrCf/corto" );
				if (( len(THIS.value) GT 11 ) AND ( len(THIS.value) LT 16 )) myErr = addDataError( THIS.key, "errori/ivaOrCf/lunghezzaErrata" );
				if ( len(THIS.value) GT 16 ) myErr = addDataError( THIS.key, "errori/ivaOrCf/lungo" );
			break;
		
		}//END Switch
		return( myErr );
	</cfscript>

</cffunction>


<!--- CK: 
	controlla CAP (italia) 
--->
<cffunction name="isCAP" access="private" returntype="boolean" output="no">

	<cfscript>
		myErr = TRUE;
		if ( len(THIS.value) IS 5 ) {
			if ( REFindNoCase("[0-9]{5}", THIS.value, 1 ) NEQ 1) myErr = addDataError( THIS.key, "errori/cap/caratteriErrati" );
			// qui bisogna inserire il controllo mancante 
			// if ( ) myErr = addDataError(THIS.key, "errori/iva/nonValido");
		}
		else {
			if ( len(THIS.value) LT 5 ) myErr = addDataError( THIS.key, "errori/cap/corto" );
			if ( len(THIS.value) GT 5 ) myErr = addDataError( THIS.key, "errori/cap/lungo" );
		}
		return( myErr );
	</cfscript>

</cffunction>


<!--- 
	CK: controlla un indirizzo email
--->
<cffunction name="isMail" access="private" returntype="boolean" output="no">
	
	<cfscript>
		myErr = TRUE;
		if (REFindNoCase("^([\w\d\-\.]+)@{1}(([\w\d\-]{1,67})|([\w\d\-]+\.[\w\d\-]{1,67}))\.(([a-zA-Z\d]{2,4})(\.[a-zA-Z\d]{2})?)$", THIS.value, 1) NEQ 1) 
			myErr = addDataError( THIS.key, "errori/email/nonValido" );
		return( myErr );
	</cfscript>

</cffunction>


<!--- 
	CK: controlla un numero di telefono 
--->
<cffunction name="isTelefono" access="private" returntype="boolean" output="no">
	
	<cfscript>
		myErr = TRUE;
		if ( Len(ReplaceList(THIS.value, "1,2,3,4,5,6,7,8,9,0,.,-,/,+", ",,,,,,,,,,,,,")) GT 0 ) 
			myErr = addDataError( THIS.key, "errori/telefono/nonValido" ); 
		else {
			tmpStr = ReplaceList(THIS.value, ".,-,/,+", ",,,");
			if ( len(tmpStr) GT 15 ) myErr = addDataError( THIS.key, "errori/telefono/troppoLungo" ); 
			if ( len(tmpStr) LT 8 ) myErr = addDataError( THIS.key, "errori/telefono/troppoCorto" ); 
		}
		return( myErr );
	</cfscript>

</cffunction>


<!---
	UTILS: sceglie quale controllo eseguire e lo esegue
--->
<cffunction name="isCheckOK" access="private" returntype="boolean">
	<cfargument name="ck" type="struct" required="yes">
	
	<cfscript>
		//da per SCONTATO che i CK siano sintatticamente corretti
		myConclusion=TRUE;
		//dumpme(ARGUMENTS);
		switch( ARGUMENTS.ck.type ) {

			// valore non nullo
			case "notNull":	
				if (THIS.value IS "") myConclusion = addDataError( THIS.key, "errori/generico/mandatory" );
 			break;
			
			// valore numerico
			case "isNumber":	
				if ( NOT LSIsNUmeric(THIS.value) ) myConclusion = addDataError( THIS.key, "errori/numeri/nonValido" );
			break;
			
			// numero e diverso da un numero dato
			case "notThisNumber":	
				if ( NOT LSIsNUmeric(THIS.value) ) 
					myConclusion = addDataError( THIS.key, "errori/numeri/nonValido" );
				else 
					if ( val(THIS.value) IS val(ARGUMENTS.ck.number) ) 
					myConclusion = addDataError( THIS.key, "errori/generico/nonValido" );
			break;
			
			// diverso da valore dato NB: non e' detto che choose e val siano numeri
			case "notThisVal": 
				if (THIS.value IS ARGUMENTS.ck.val) myConclusion = addDataError( THIS.key, "errori/generico/nonValido" ); 
			break;
			
			// diverso da valore dato NB: non e' detto che choose e val siano numeri
			case "notThisOption": 
				if (THIS.value IS ARGUMENTS.ck.option) myConclusion = addDataError( THIS.key, "errori/dropdown/mandatory" ); 
			break;
			
			// codice fiscale
			case "isCF":	myConclusion = isCF( THIS.key, THIS.value ); break;
			
			// p. IVA
			case "isIVA":	myConclusion = isIVA( THIS.key, THIS.value ); break;
			
			// IVA o CF
			case "isIVAorCF":	myConclusion = isIVAorCF( THIS.key, THIS.value ); break;
			
			// CAP (italiano)
			case "isCAP":	myConclusion = isCAP( THIS.key, THIS.value ); break;

			// email
			case "isMail":	myConclusion = isMail( THIS.key, THIS.value ); break;
			
			// numero di telefono
			case "isTelefono":	myConclusion = isTelefono( THIS.key, THIS.value ); break;
			
			// data
			case "isDataMix":	
				if ( Len(ReplaceList(THIS.value, "1,2,3,4,5,6,7,8,9,0,/", ",,,,,,,,,,")) GT 0 ) 
					myConclusion = addDataError( THIS.key, "errori/data/nonValido" ); 
				else if ( NOT LSisDate(THIS.value) ) myConclusion = addDataError( THIS.key, "errori/data/nonData" ); 
			break;
			
			// checkbox spuntatata
			case "isON":	
				if ( NOT ((THIS.value IS "off") OR (THIS.value IS "")) ) myConclusion = addDataError( THIS.key, "errori/checkbox/mandatory" ); 
			break;
			
			// ERRORE
			default: 
				SESSION.mixForms.sysErrObj.write( "CHECK type ["& ARGUMENTS.ckStruct.type & "] is unknown" );
			break;
				
		}//END Switch
		return( myConclusion );
	</cfscript>
	
</cffunction>

</cfcomponent>