<cfcomponent 
	displayname="writeChecks" 
	extends="base" 
	hint="esefue i controlli per vedere se una linea della form deve essere scritta o meno"
>


<!---
	UTILS: sceglie quale controllo eseguire e lo esegue
--->
<cffunction name="isCheckOK" access="private" returntype="boolean">
	<cfargument name="ckStruct" type="struct" required="yes">
	
	<cfscript>
		//da per SCONTATO che i CK siano sintatticamente corretti
		myConclusion=true;
		switch( ARGUMENTS.ckStruct.type ) {

			// almeno una delle flag coincide
			case "okFlag": 
				if ( NOT isListMatch( THIS.FL, ARGUMENTS.ckStruct.list ) ) myConclusion=false;
			break;
			
			// nessuna delle flag coincide
			case "noFlag":
				if ( isListMatch( THIS.FL, ARGUMENTS.ckStruct.list ) ) myConclusion=false; 
			break;
			
			// linguaggio incluso nella lista
			case "okLang":
				if ( NOT ListContainsNoCase( ARGUMENTS.ckStruct.list, THIS.lang )) myConclusion=false;
			break;
				
			// linguaggio escluso dalla lista
			case "noLang":
				if ( ListContainsNoCase( ARGUMENTS.ckStruct.list, THIS.lang )) myConclusion=false;
			break;

			// la linea e' valida da una certa data in poi
			case "beginDate":
				if ( dateDiff("D", now(), LSParseDateTime(ARGUMENTS.ckStruct.date) ) GT 0 ) myConclusion=false;
			break;

			// la linea e' valida fino ad una certa data
			case "endDate":
				if ( dateDiff("D", now(), LSParseDateTime(ARGUMENTS.ckStruct.date) ) LT 0 ) myConclusion=false;
			break;

			// ERRORE
			default: 
				THIS.sysErrObj.write( "CHECK type ["& ARGUMENTS.ckStruct.type & "] is unknown" ); myConclusion=false;
			break;
				
		}//END Switch

		//writeOutput("myConclusion=[" & myConclusion & "]<br />");
		return(myConclusion);
	</cfscript>
	
</cffunction>


</cfcomponent>