<cfcomponent 
	displayname="ERROR HOLDER" 
	hint="oggetto che contiene i messaggi di errore">

<!--- COSTRUTTORE --->
<cfscript>
	init();
</cfscript>

<!--- torna TRUE se non ci sono errori -------------------------->
<cffunction name="errorFree" access="public" returntype="boolean">

	<cfscript>
		MyRet=FALSE;
		if (THIS.eNumber EQ 0) MyRet=TRUE;
		return(MyRet);
	</cfscript>

</cffunction>


<!--- addizione un errore "a mano" -------------------------->
<cffunction name="addError" access="public" returntype="void">
	<cfargument name="MyName" type="string" required="yes">
	<cfargument name="MyMessage" type="struct" required="yes">

	<cfscript>
		THIS.e[MyName]=MyMessage;
		THIS.eNumber++;
	</cfscript>

</cffunction>


<!--- addiziona un errore da XML ----------------------------------->
<cffunction name="addErrorFromXML" access="public" returntype="void">
	<cfargument name="MyName" type="string" required="yes">
	<cfargument name="MyPath" type="string" required="yes">

	<cfscript>
		MyPath = MyPath & "/messaggio";
		ResultArray=XMLSearch( THIS.MyErrorXML, MyPath );
		THIS.e[MyName]=StructNew();
		for (i=1; i LTE ArrayLen(ResultArray); i++)
			THIS.e[MyName][ ResultArray[i].XmlAttributes.lang ]= ResultArray[i].XmlText;
		THIS.eNumber++;
	</cfscript>

</cffunction>

<!--- addiziona un errore da variabile (esterna) XML ------------------>
<cffunction name="addErrorFromXMLvar" access="public" returntype="void">
	<cfargument name="MyName" type="string" required="yes">
	<cfargument name="MyXML" type="xml" required="yes">

	<cfscript>
		MyPath = "extMsg/messaggio";
		ResultArray=XMLSearch( MyXML, MyPath );
		THIS.e[MyName]=StructNew();
		for (i=1; i LTE ArrayLen(ResultArray); i++)
			THIS.e[MyName][ ResultArray[i].XmlAttributes.lang ]= ResultArray[i].XmlText;
		THIS.eNumber++;
	</cfscript>

</cffunction>


<!--- ritorna stringa con errore data Key --------------------->
<cffunction name="getError" access="public" returntype="string">
	<cfargument name="MyName" type="string" required="yes">

	<cfscript>
		MyRet="";
		if ( StructKeyExists(THIS.e, MyName) ) 
			if ( StructKeyExists(THIS.e[MyName], THIS.language) )  MyRet=THIS.e[MyName][THIS.language];  
			else  MyRet="GENERAL ERROR: (no message for this error in this language) "; 
		return(MyRet);
	</cfscript>

</cffunction>


<!--- ritorna stringa con errore data Key --------------------->
<cffunction name="getGeneralError" access="public" returntype="string">

	<cfscript>
		// carica un errorre "fittizio"
		switch ( THIS.eNumber ) {
			case 0: break;
			case 1: addErrorFromXML("generale", "errori/generale/unErrore"); break;
			default: addErrorFromXML("generale", "errori/generale/dueErrori"); break;
		}//END Switch
		
		// tolgie uno agli errori 
		THIS.eNumber--;
		
		// sceglie il linguaggio giusto
		if ( StructKeyExists(THIS.e.generale, THIS.language) )  MyRet=THIS.e.generale[THIS.language];  
		else  MyRet="GENERAL ERROR: (no message for this error in this language) "; 

		return(MyRet);
	</cfscript>

</cffunction>
		

<!--- rirorna TRUE se c'e' errore su quella key --------------->
<cffunction name="isError" access="public" returntype="boolean">
	<cfargument name="MyName" type="string" required="yes">

	<cfscript>
		MyRet=false;
		if ( StructKeyExists(THIS.e, MyName) ) MyRet=true;
		return(MyRet);
	</cfscript>

</cffunction>

<!--- cancella un messaggio di errore da una key --------------->
<cffunction name="deleteError" access="public" returntype="void">
	<cfargument name="MyName" type="string" required="yes">

	<cfscript>
		if ( StructKeyExists(THIS.e, MyName) ) {
			StructClear(THIS.e[MyName]);
			THIS.eNumber--;
		}
	</cfscript>

</cffunction>


<!--- Gestisce il linguaggio ----------------------------------->
<cffunction name="setLanguage" access="public" returntype="void">
	<cfargument name="MyLanguage" type="string" required="yes">
	<cfscript>
		if ( len(MyLanguage) EQ 2) {	THIS.language=MyLanguage; }
	</cfscript>
</cffunction>

<cffunction name="getLanguage" access="public" returntype="string">
	<cfreturn THIS.language >
</cffunction>

<cffunction name="debug" access="public" returntype="string">
	<cfoutput>
		language = #THIS.language#<br />
		e number = #THIS.eNumber#<br />
	</cfoutput>
	<cfdump var="#THIS.e#">
	<br />
</cffunction>


<!--- Clear ---------------------------------------------->
<cffunction name="clearError" access="public" returntype="void">
	<cfscript>
		THIS.language="it";
		THIS.eNumber=0;
		THIS.e=structNew();
	</cfscript>
</cffunction>

<!--- COSTRUTTORE --------------------------------------->
<cffunction name="init" access="public" returntype="void">
	<cfscript>
		THIS.language="it";
		THIS.eNumber=0;
		THIS.e=structNew();
		MyFile = GetDirectoryFromPath( GetCurrentTemplatePath() ) & "messaggi_default.xml";
	</cfscript>

	<cffile action="read" file="#MyFile#" variable="THIS.MyErrorFile">

	<cfscript>
		THIS.MyErrorXML=XMLParse(THIS.MyErrorFile, "no");
		THIS.MyErrorFile="";
	</cfscript>
</cffunction>


</cfcomponent>