<cfcomponent>

<cfscript>init();</cfscript>

<!--- 
	GETTER: isError ed isWarning
--->
<cffunction name="isOK" access="public" returntype="boolean">
	<cfset myRet = FALSE>
	<cfif THIS.error IS 0 ><cfset myRet = TRUE></cfif>
	<cfreturn myRet>
</cffunction>

<cffunction name="isWarning" access="public" returntype="boolean">
	<cfset myRet = TRUE>
	<cfif THIS.warning IS 0 ><cfset myRet = FALSE></cfif>
	<cfreturn myRet>
</cffunction>


<!--- 
	GETTER & SETTER: debug
--->
<cffunction name="isDebug" access="public" returntype="boolean">
	<cfreturn THIS.debug>
</cffunction>

<cffunction name="setDebugON" access="public" returntype="void">
	<cfset THIS.debug = TRUE >
</cffunction>

<cffunction name="setDebugOFF" access="public" returntype="void">
	<cfset THIS.debug = FALSE >
</cffunction>


<!--- 
	RESET: rimette le cariabili allo stato iniziale
--->
<cffunction name="reset" access="public" returntype="void">
	<cfset THIS.error=0>
	<cfset THIS.warning=0>
	<cfset THIS.debug=TRUE>
</cffunction>


<!---
	UTILITY: scrittura degli errori 
--->
<cffunction name="write" access="public" returntype="void">
	<cfargument name="myMsg" type="string" required="yes">
	<cfargument name="myType" type="string" required="no" default="error">

	<cfscript>
		switch( ARGUMENTS.myType ){
			case "error": 
				THIS.error++;
				if (THIS.debug) writeOutput("** <strong>ERROR</strong> ** <i>" & ARGUMENTS.myMsg & "</i><br />");
			break;
			case "warning": 
				THIS.warning++;
				if (THIS.debug) writeOutput("** <strong>WARNING</strong> ** <i>" & ARGUMENTS.myMsg & "</i><br />");
			break;
			default: 
				THIS.error++;
				if (THIS.debug) {
					writeOutput("** <strong>ERROR</strong> ** <i>Unknown error type writing error</i>");
					writeOutput("** <strong>?????</strong> ** <i>" & ARGUMENTS.myMsg & "</i><br />");
				}
			break;
		}//END switch
	</cfscript>

</cffunction>

<!---
	COSTRUTTORE
--->
<cffunction name="init" access="private" returntype="void">
	<cfscript>
		reset();
	</cfscript>
</cffunction>

</cfcomponent>